/************************************************************************
*                       - INFOFLEX System -
* This source code is CONFIDENTIAL and PROPRIETARY to CUSTOMWARE COMPUTING,
* INC. (CWC). The information contained herein may not be used, copied or
* disclosed in whole or in part except as permitted by written agreement
* signed by an officer of CWC.
*
* COPYRIGHT (c) 1986 CUSTOMWARE COMPUTING, INC., BURLINGAME, CALIFORNIA.
* ALL RIGHTS RESERVED.
*
* Version: %V%  %R%
* Date: %D%  %T%
*************************************************************************/

/* changed non-substantially, 3/18/88, so compatible with flex.h (ag) */
/* 3 ifndefs: FUNCLBL, TERMVAR, TERMHDR */

#ifndef FUNCLBL
typedef struct {
     short fl_number;
     char fl_label[ 5];
     } FUNCLBL;
#endif

#define N_FUNCLBL    25 
#define FUNCSIZE     6
#define CRTSIZE      100 
#define ACTSIZE      10
#define CRTCODES    1
#define ACTIONCODES 2
#define KH_MAGIC    0x1248
#define ACTSTART    1000 

#define GRAPHSTART  169    /* be setting to 169 then grapics chars will
                              fall in the range of (169 + 47)  to (169 + 87) */

#ifndef TERMVAR
typedef struct {
   short  tv_nactseq;             /* total # of action keys */
   char   **tv_actseq;            /* array of action key sequences */
   short  tv_ncrtseq;             /* total # of crt control seq's */
   char   **tv_crtseq;            /* array of pointers to crt sequences */
} TERMVAR;
#endif





#ifndef TERMHDR
typedef struct {
 char th_magic[2];     /* magic number (always KH_MAGIC) */
 char th_version[16];  /* version information */
 char th_termname[16]; /* terminal name    */
 char th_nactseq[2];   /* total # of action keys */
 char th_actnalloc[2]; /* total # of function key labels */
 char th_ncrtseq[2];   /* total # of crt control sequences */
 char th_crtnalloc[2]; /* total # of bytes for crt ctrl sequences */
 char tv_filler[2];    /* fill out structure for worst case alignment
                                 (ie. multiple of 4)    */
} TERMHDR;
#endif

#ifndef MOUSEVAR 
typedef struct {
   short button; 
   short row;    
   short col;    
   short release_row;
   short release_col;
   short doubleclick;
   short flags;
} MOUSEVAR;
#endif


/* ACTION keys  */
#define ESCAPEKEY    (ACTSTART+1)
#define ENTERKEY     (ACTSTART+2)
#define LINEFEED     (ACTSTART+3)
#define FWRDTAB      (ACTSTART+4)
#define BACKTAB      (ACTSTART+5)
#define BACKSPACE    (ACTSTART+6)
#define UPARROW      (ACTSTART+7)
#define SUPARROW     (ACTSTART+8)
#define DOWNARROW    (ACTSTART+9)
#define SDOWNARROW   (ACTSTART+10)
#define RIGHTARROW   (ACTSTART+11)
#define SRIGHTARROW  (ACTSTART+12)
#define LEFTARROW    (ACTSTART+13)
#define SLEFTARROW   (ACTSTART+14)
#define INSERTKEY    (ACTSTART+15)
#define DELETEKEY    (ACTSTART+16)
#define INSERTLIN    (ACTSTART+17)
#define DELETELIN    (ACTSTART+18)
#define USERLKEY     (ACTSTART+19)
#define HELP2KEY     (ACTSTART+20)

/*  FUNCTION Keys   */
#define F1_KEY        (ACTSTART+21)     /* F1  */
#define F2_KEY        (ACTSTART+22)     /* F1  */
#define F3_KEY        (ACTSTART+23)     /* F1  */
#define F4_KEY        (ACTSTART+24)     /* F1  */
#define F5_KEY        (ACTSTART+25)     /* F1  */
#define F6_KEY        (ACTSTART+26)     /* F1  */
#define F7_KEY        (ACTSTART+27)     /* F1  */
#define F8_KEY        (ACTSTART+28)     /* F1  */
#define F9_KEY        (ACTSTART+29)     /* F1  */
#define F10_KEY       (ACTSTART+30)     /* F1  */
#define F11_KEY       (ACTSTART+31)     /* F1  */
#define F12_KEY       (ACTSTART+32)     /* F1  */
#define F13_KEY       (ACTSTART+33)     /* F1  */
#define F14_KEY       (ACTSTART+34)     /* F1  */
#define F15_KEY       (ACTSTART+35)     /* F1  */
#define F16_KEY       (ACTSTART+36)     /* F1  */
#define F17_KEY       (ACTSTART+37)     /* F1  */
#define F18_KEY       (ACTSTART+38)     /* F1  */
#define F19_KEY       (ACTSTART+39)     /* F1  */
#define F20_KEY       (ACTSTART+40)     /* F1  */
#define F21_KEY       (ACTSTART+41)     /* F1  */
#define F22_KEY       (ACTSTART+42)     /* F1  */
#define F23_KEY       (ACTSTART+43)     /* F1  */
#define F24_KEY       (ACTSTART+44)     /* F1  */
#define F25_KEY       (ACTSTART+45)     /* F1  */
#define HOMEKEY     (ACTSTART+46)
#define ENDKEY       (ACTSTART+47)
#define PAGEUP       (ACTSTART+48)
#define PAGEDOWN     (ACTSTART+49)
#define MOUSEKEY      (ACTSTART+50)     /* MOUSE */

#define SAVEKEY       (ACTSTART+21)     /* F1  */
#define DUPKEY        (ACTSTART+22)     /* F2  */
#define JUMPKEY       (ACTSTART+23)     /* F3  */
#define MODEKEY       (ACTSTART+24)     /* F4  */
#define SEARCHKEY     (ACTSTART+25)     /* F5  */
#define FINDKEY       (ACTSTART+26)     /* F6  */
#define PREVKEY       (ACTSTART+27)     /* F7  */
#define NEXTKEY       (ACTSTART+28)     /* F8  */
#define FIRSTKEY      (ACTSTART+29)     /* F9  */
#define LASTKEY       (ACTSTART+30)     /* F10 */
#define PRINTKEY      (ACTSTART+31)     /* F11 */
#define DELKEY        (ACTSTART+32)     /* F12 */
#define ZOOMKEY       (ACTSTART+33)     /* F13 */
#define HELPKEY       (ACTSTART+34)     /* F14 */
#define SKIPKEY       (ACTSTART+35)     /* F15 */
#define QUERYKEY      (ACTSTART+36)     /* F16 */
#define USER1KEY      (ACTSTART+37)     /* F17 */
#define USER2KEY      (ACTSTART+38)     /* F18 */
#define USER3KEY      (ACTSTART+39)     /* F19 */
#define USER4KEY      (ACTSTART+40)     /* F20 */
#define USER5KEY      (ACTSTART+41)     /* F21 */
#define USER6KEY      (ACTSTART+42)     /* F22 */
#define USER7KEY      (ACTSTART+43)     /* F23 */
#define USER8KEY      (ACTSTART+44)     /* F24 */
#define USER9KEY      (ACTSTART+45)     /* F25 */
#define DUMMYKEY      (ACTSTART+999)

/* end of Action Key sequence MACROS */


#define ESCSAVEKEY ACTSTART + 100

/* CONTROL KEYS */
#define CTL_AKEY (ACTSTART + 101)
#define CTL_BKEY (ACTSTART + 102)
#define CTL_CKEY (ACTSTART + 103)
#define CTL_DKEY (ACTSTART + 104 ) /* DOC */
#define CTL_EKEY (ACTSTART + 105)                       
#define CTL_FKEY (ACTSTART + 106)  /* USER DEFINABLE */
#define CTL_GKEY (ACTSTART + 107)  /* USER DEFINABLE */
#define CTL_HKEY (ACTSTART + 108)  /* UNIX */
#define CTL_IKEY (ACTSTART + 109)
#define CTL_JKEY (ACTSTART + 110)  /* UNIX */
#define CTL_KKEY (ACTSTART + 111)  /* USER DEFINABLE */
#define CTL_LKEY (ACTSTART + 112)  /* USER DEFINABLE */
#define CTL_MKEY (ACTSTART + 113)  /* UNIX */
#define CTL_NKEY (ACTSTART + 114)
#define CTL_OKEY (ACTSTART + 115)
#define CTL_PKEY (ACTSTART + 116)  /* DOC  */
#define CTL_QKEY (ACTSTART + 117)  /* UNIX */
#define CTL_RKEY (ACTSTART + 118)  /* USER DEFINABLE - REFRESH */
#define CTL_SKEY (ACTSTART + 119)  /* UNIX */
#define CTL_TKEY (ACTSTART + 120)
#define CTL_UKEY (ACTSTART + 121)
#define CTL_VKEY (ACTSTART + 122)
#define CTL_WKEY (ACTSTART + 123)
#define CTL_XKEY (ACTSTART + 124)  /* USER DEFINABLE */
#define CTL_YKEY (ACTSTART + 125)
#define CTL_ZKEY (ACTSTART + 126)  /* USER DEFINABLE */
#define CTL_28KEY (ACTSTART + 128)  /* CTL \ */
#define CTL_29KEY (ACTSTART + 129)  /* CTL ] */

/* ATTRIBUTE TYPES */
#define DA_MENU     0  /* menu literals */
#define DA_BMENU    1  /* menu border  */
#define DA_PMENU    2  /* menu choice */
#define DA_CMENU    3  /* menu current choice */
#define DA_POPMENU  4  /* popmenu literals   */
#define DA_BPOPMENU 5  /* popmenu border  */
#define DA_PPOPMENU 6  /* popmenu choice  */
#define DA_CPOPMENU 7  /* popmenu current choice  */
#define DA_SCREEN   8  /* screen literals */
#define DA_BSCREEN  9 /* screen border */
#define DA_FIELD    10 /* screen fields   */
#define DA_CURFIELD 11 /* screen current field */
#define DA_SRCHFIELD 12 /* screen search field */
#define DA_REPORT   13  /* Report */
#define DA_VIEWER   14  /* Report viewer */
#define DA_HELP     15  /* help  */
#define DA_HELP2    16  /* help  */
#define DA_ERRMSG   17  /* error message */
#define DA_STATMSG  18  /* status message */
#define DA_COMMSG   19  /* comment message */
#define DA_PROMPT   20  /* prompt message */
#define DA_FMSG     21  /* function key number message */
#define DA_FLABEL   22  /* function key label message */
#define DA_TITLE    23  /* Titles on screens and menus */
#define DA_PMENU_NO 24  /* Menu choices not permitted */
#define DA_FIELD_NO 25  /* Screen fields not enterable */
#define DA_MODEMSG  26  /* Screen Mode message      */

/* special attribute for fields  */
#define BRACKET     161
#define REVBAR      162

#define TERM_WEB       1
#define TERM_XTERM     2
#define TERM_MULTIVIEW 3
#define TERM_LINUX     4
#define TERM_ANITA     5 
#define TERM_AXEL      6 


#ifdef UNIX
      /* CRT sequences*/
#define M_TYPE         0
#define M_RESET        1
#define M_AUXON        2
#define M_AUXOFF       3
#define M_TPON         4
#define M_TPOFF        5
#define C_CLR          6    /* clear screen */
#define C_EOS          7    /* clear to end-of-screen */
#define C_EOL          8    /* clear to end-of-line */
#define C_BOL          9    /* clear screen */

      /* CURSOR sequences */
#define C_CON          10 /* clear screen */
#define C_COFF         11    /* clear screen */
#define C_CU           12    /* clear screen */
#define C_CUB          13    /* clear screen */
#define C_CB           14    /* clear screen */
#define C_CBB          15    /* clear screen */
#define C_UP           16    /* clear screen */
#define C_DOWN         17    /* clear screen */
#define C_LEFT         18    /* clear screen */
#define C_RIGHT        19    /* clear screen */
#define C_HOME         20    /* clear screen */
#define C_LEAD         21    /* lead-in sequence */
#define C_SEPAR        22    /* separator between row and column */
#define C_TRAIL        23    /* trailing sequence */
#define C_ROWSET       24    /* row offset */
#define C_COLSET       25    /* column offset */


      /* ATTRIBUTE sequences */
#define A_HON        26
#define A_HOFF       (A_HON+1)
#define A_BON        (A_HON+2)
#define A_BOFF       (A_HON+3)
#define A_RON        (A_HON+4)
#define A_ROFF       (A_HON+5)
#define A_RBON       (A_HON+6)
#define A_RBOFF      (A_HON+7)
#define A_RDON       (A_HON+8)
#define A_RDOFF      (A_HON+9)
#define A_UON        (A_HON+10)
#define A_UOFF       (A_HON+11)
#define A_UBON       (A_HON+12)
#define A_UBOFF      (A_HON+13)
#define A_URBON      (A_HON+14)
#define A_URBOFF     (A_HON+15)
#define A_HIDON      (A_HON+16)
#define A_HIDOFF     (A_HON+17)

  /* GRAPHIC sequences */
#define G_TYPE      (A_HIDOFF+1)
#define G_ON        (G_TYPE+1)    /* turn on attribute */
#define G_OFF       (G_ON+1)
#define GL_THL      (G_ON+2)   /* 47 */
#define GL_BHL      (G_ON+3)
#define GL_LVL      (G_ON+4)
#define GL_RVL      (G_ON+5)
#define GL_LTC      (G_ON+6)    /* single line - Left Top Corner  */
#define GL_RTC      (G_ON+7)    /* single line - Right Top Corner  */
#define GL_LBC      (G_ON+8)    /* single line - Left Bottom Corner  */
#define GL_RBC      (G_ON+9)    /* single line - Right Bottom Corner  */
#define GL_LHT      (G_ON+10)    /* single line - Left Horizontal 'T'  */
#define GL_RHT      (G_ON+11)    /* single line - Right Horizontal 'T' */
#define GL_TVT      (G_ON+12)   /* single line - Top Vertical 'T'  */
#define GL_BVT      (G_ON+13)   /* single line - Bottom Vertical 'T'  */
#define GL_CX       (G_ON+14)   /* single line - Bottom Vertical 'T'  */

#define GD_THL      (GL_CX+1)
#define GD_BHL      (GL_CX+2)
#define GD_LVL      (GL_CX+3)
#define GD_RVL      (GL_CX+4)
#define GD_LTC      (GL_CX+5)    /* single line - Left Top Corner  */
#define GD_RTC      (GL_CX+6)    /* single line - Right Top Corner  */
#define GD_LBC      (GL_CX+7)    /* single line - Left Bottom Corner  */
#define GD_RBC      (GL_CX+8)    /* single line - Right Bottom Corner  */
#define GD_LHT      (GL_CX+9)    /* single line - Left Horizontal 'T'  */
#define GD_RHT      (GL_CX+10)    /* single line - Right Horizontal 'T' */
#define GD_TVT      (GL_CX+11)    /* single line - Top Vertical 'T'  */
#define GD_BVT      (GL_CX+12)    /* single line - Bottom Vertical 'T'  */
#define GD_CX       (GL_CX+13)    /* single line - Bottom Vertical 'T'  */

#define GR_THL      (GD_CX+1)
#define GR_BHL      (GD_CX+2)
#define GR_LVL      (GD_CX+3)
#define GR_RVL      (GD_CX+4)
#define GR_LTC      (GD_CX+5)    /* single line - Left Top Corner  */
#define GR_RTC      (GD_CX+6)    /* single line - Right Top Corner  */
#define GR_LBC      (GD_CX+7)    /* single line - Left Bottom Corner  */
#define GR_RBC      (GD_CX+8)    /* single line - Right Bottom Corner  */
#define GR_LHT      (GD_CX+9)    /* single line - Left Horizontal 'T'  */
#define GR_RHT      (GD_CX+10)    /* single line - Right Horizontal 'T' */
#define GR_TVT      (GD_CX+11)    /* single line - Top Vertical 'T'  */
#define GR_BVT      (GD_CX+12)    /* single line - Bottom Vertical 'T'  */
#define GR_CX       (GD_CX+13)    /* single line - Bottom Vertical 'T'  */

#define T_TABCLR    (GR_CX+1)    /* Clear all Tab settings */
#define T_TABSET    (T_TABCLR+1)  /* Tab Set character */
#define T_TAB       (T_TABCLR+2)  /* Tab Character  */
#define T_NEWLINE   (T_TABCLR+3)  /* Carriage Return & Line Feed */
#define A_TYPE      (T_TABCLR+4)  /* Attribute type -
                                       1 =  character by character
                                       0 =  ON/OFF attribute bytes
                                  */
#define T_80COL     (T_TABCLR+5)
#define T_133COL     (T_TABCLR+6)
#define T_MARGIN     (T_TABCLR+7)
#define T_INSERT     (T_TABCLR+8)
#define T_DELETE     (T_TABCLR+9)
/* end of Terminal control && Attribute sequence MACROS */



/* Screen attributes */
#define NORMAL      A_HIDOFF
#define BLINK       A_BON
#define UNDERLINE   A_UON
#define REVERSE     A_RON
#define REVBLINK    A_RBON
#define DIMREVERSE  A_RDON
#define DIM         A_HON
#define ON_PROTECT  A_HIDON   
#define OFF_PROTECT A_HIDOFF   


#endif



#ifdef MSDOS

#define C_ROWSET       24    /* row offset */
#define C_COLSET       25    /* column offset */

#define GL_THL   196       /* single line - Horizontal Line */
#define GL_BHL   196       /* single line - Horizontal Line */
#define GL_LVL   179     /* single line - Vertical Line  */
#define GL_RVL   179     /* single line - Vertical Line  */
#define GL_LTC  218     /* single line - Left Top Corner  */
#define GL_RTC  191     /* single line - Right Top Corner  */
#define GL_LBC  192     /* single line - Left Bottom Corner  */
#define GL_RBC  217     /* single line - Right Bottom Corner  */
#define GL_LHT  195     /* single line - Left Horizontal 'T'  */
#define GL_RHT  180     /* single line - Right Horizontal 'T' */
#define GL_TVT  194     /* single line - Top Vertical 'T'  */
#define GL_BVT  193     /* single line - Bottom Vertical 'T'  */
#define GL_CX   197     /* single line - Cross '+'            */

#define GD_THL    205    /* double line - Horizontal Line */
#define GD_BHL    205    /* double line - Horizontal Line */
#define GD_LVL    186    /* double line - Vertical Line  */
#define GD_RVL    186    /* double line - Vertical Line  */
#define GD_LTC   201    /* double line - Left Top Corner  */
#define GD_RTC   187    /* double line - Right Top Corner  */
#define GD_LBC   200    /* double line - Left Bottom Corner  */
#define GD_RBC   188    /* double line - Right Bottom Corner  */
#define GD_LHT   204    /* double line - Left Horizontal 'T'  */
#define GD_RHT   185      /* double line - Right Horizontal 'T' */
#define GD_TVT   203    /* double line - Top Vertical 'T'  */
#define GD_BVT   202    /* double line - Bottom Vertical 'T'  */
#define GD_CX    206    /* double line - Cross '+'            */

#define GR_THL 223
#define GR_BHL 220
#define GR_LVL 219
#define GR_RVL 219

#define GR_LTC 219
#define GR_RTC 219
#define GR_LBC 219
#define GR_RBC 219
#define GR_LHT 219
#define GR_RHT 219
#define GR_TVT 219
#define GR_BVT 219


/*  Screen attribute */
#define DIM         7          /* usually called NORMAL on IBM  */
#define INTENSE     8
#define UNDERLINE   1     | INTENSE
#define NORMAL      7     | INTENSE
#define REVERSE     0x70  | INTENSE
#define BLINK       0x80  | NORMAL
#define REVBLINK    BLINK | REVERSE
#define DIMREVERSE  DIM   | REVERSE
#define BLACK       0
#define BLUE        1
#define GREEN       2
#define CYAN        3
#define RED         4
#define MAGENTA     5
#define BROWN       6
#define GREY        7

#define DARKGREY   (BLACK + 8) /* adding 8 creates brighter version of above */
#define YELLOW     (BROWN + 8)
#define WHITE      (GREY  + 8)

#define ON_PROTECT  DIM   
#define OFF_PROTECT NORMAL   

#define T_NEWLINE   '\n'          /* Carriage Return & Line Feed */

#define C_COFF  0
#define C_CON   1

/*  NEED FOR MULTIVIEW CALLS - not really used unless on UNIX */
#define A_RDON   DIM 
#define A_UBON   NORMAL 

#endif
