/*
*                       - INFOFLEX System -
* This source code is CONFIDENTIAL and PROPRIETARY to CUSTOMWARE COMPUTING,
* INC. (CWC). The information contained herein may not be used, copied or
* disclosed in whole or in part except as permitted by written agreement
* signed by an officer of CWC.
*
* COPYRIGHT (c) 1986 CUSTOMWARE COMPUTING, INC., BURLINGAME, CALIFORNIA.
* ALL RIGHTS RESERVED.
*
* Version: %V%  %R%
* Date: %D%  %T%
*************************************************************************/

#define DBOPEN     1
#define DBCLOSE    2
#define FILEOPEN   3
#define RELOPEN    3
#define FILECLOSE  4
#define RELCLOSE   4

#define OPENMASK	0x00ff
#define EXCLUSIVE	0x0100
#define READONLY	0x0200
#define READWRITE	0x0000

#define COMPARISON 1
#define FIRST	   2
#define LAST	   3
#define NEXT	   4
#define PREVIOUS   5
#define EQUAL	   6
#define GTEQ	   7
#define GREATER	   8
#define CURRENT    9
#define LOCK	   0400

/* values passed to dbselfield() */
#define ACCKEYED	0
/* #define ACCPRIMARY	1 */
#define ACCSEQUENTIAL	2

/* GWM comment out types for fxtypes.h */
#ifdef ALL_TYPES
struct dbview
    {
    char *vwname;	/* name of attribute	*/
    int vwstart;	/* offset in view	*/
    int vwtype;		/* type of attribute	*/
    int vwlen;		/* length in bytes	*/
    int vwoffs;		/* Offset of source buffer*/
    };

#define CHARTYPE	0
#define INTTYPE		1
#define INTSIZE		2
#define LONGTYPE	2
#define LONGSIZE	4
#define DOUBLETYPE	3
#define DOUBLESIZE	(sizeof(double))
#define FLOATTYPE	4
#define FLOATSIZE	(sizeof(float))
#define SERIALTYPE	(0x0100 + LONGTYPE)
#define SERIALSIZE	LONGSIZE
#define DATETYPE	(0x0200 + LONGTYPE)
#define EDATETYPE	(0x0300 + LONGTYPE)
#define YDATETYPE	(0x0400 + LONGTYPE)
#define DATESIZE	LONGSIZE
#define MONEYTYPE	(0x0500 + DOUBLETYPE)
#define MONEYSIZE	DOUBLESIZE
#define COMPOSTYPE	(-1)
#endif

extern double round();

#define	CENTS(d)	(round((d)*100.0))
#define DOLLARS(c)	((c)/100.0)
#define ROUND(c)	(round(c))

/* values returned by dbindex() */
#define NOINDEX	0
#define NODUPS	1
#define DUPS	2


/* permission flags */

#define PERM_READ	0x0001
#define PERM_UPDATE	0x0002
#define PERM_INSERT	0x0004
#define PERM_DELETE	0x0008
#define PERM_CONTROL	0x0010
#define PERM_ALL	0x001f


