/************************************************************************
*                       - INFOFLEX System -
* This source code is CONFIDENTIAL and PROPRIETARY to CUSTOMWARE COMPUTING,
* INC. (CWC). The information contained herein may not be used, copied or
* disclosed in whole or in part except as permitted by written agreement
* signed by an officer of CWC.
*
* COPYRIGHT (c) 1986 CUSTOMWARE COMPUTING, INC., BURLINGAME, CALIFORNIA.
* ALL RIGHTS RESERVED.
*
* Version: %V%  %R%
* Date: %D%  %T%
*************************************************************************/
/*F
 *   Name: fxmenu.h  - Menu Header
 *
 *   Class: F
 *
 *   Author:  Gerard Menicucci
 *
 *   Description:
 *
 *
 *   Returns:
 *
 *   Warnings:
 *
 */


#ifdef UNIX
#include <signal.h>
#endif

typedef struct {
    char  scRow;
    char  scCol;
    char  scLength;
    char  scPermType;
    short scItemnum;
    short scBefunc;
    short scAfunc;
} SCRCHOICE;


#define MENUNMLEN  10
#define TITLELEN   76
#define ITEMTXTLEN 60


typedef struct {
    char    menuname[MENUNMLEN+1];
    char    title1[TITLELEN+1];
    char    title2[TITLELEN+1];
    char    prevmenu[ MENUNMLEN + 1];
    char    template[ 18 + 1];
    int      ncolumns;
    int      nmenufields;
    char    format[ 1 + 1];
    int     urow;
    int     ucol;
    int     lrow;
    int     lcol;

} MENUHEAD;


typedef struct {
    char    menuname[MENUNMLEN+1];
    int     itemnum;
    char    itemdesc[ITEMTXTLEN+1];
    char    exectype[1 + 1];
    char    execline[80 + 1];
    char    password[ 8+ 1];
    char    clearscr[1 + 1];
    char    startcr[1 + 1];
    char    endcr[1 + 1];
    long    menufieldid; /* MUST be last because may not exist in old version */
} MENUFIELD;

typedef struct {
    char    usercode[MENUNMLEN+1];
    char    usertype[MENUNMLEN+1];
    char    password[MENUNMLEN+1];
    char    flag1[1 + 1];
    char    flag2[1 + 1];
    char    flag3[1 + 1];
    char    description[25 + 1];
    char    dummy[30];
} MENUUSER;

typedef struct {
    char    usertype[MENUNMLEN+1];
    char    menuname[MENUNMLEN+1];
    char    password[MENUNMLEN+1];
    char    osflag[1 + 1];
    char    flag1[1 + 1];
    char    flag2[1 + 1];
    char    flag3[1 + 1];
    char    description[25 + 1];
    char    flag_ctln[1 + 1];
    char    flag_ctld[1 + 1];
    char    flag_ctlp[1 + 1];
    char    dummy[24];
} MENUUSTY;

typedef struct {
    char    usertype[MENUNMLEN+1];
    long    menufieldid; 
    char    permtype[1+1];
    char    permlist[30+1];
    char    execline[30+1];
    char    password[MENUNMLEN+1];
    char    dummy[30];
} MENUPERM;

extern USERFUNCS userfuncs[];
extern char *strcpy();
extern char *strcat();
extern char *strncat();
extern char *getword();
extern long atoul();

