/************************************************************************
*                       - INFOFLEX System -
* This source code is CONFIDENTIAL and PROPRIETARY to CUSTOMWARE COMPUTING,
* INC. (CWC). The information contained herein may not be used, copied or
* disclosed in whole or in part except as permitted by written agreement
* signed by an officer of CWC.
*
* COPYRIGHT (c) 1986 CUSTOMWARE COMPUTING, INC., BURLINGAME, CALIFORNIA.
* ALL RIGHTS RESERVED.
*
* Version: %V%  %R%
* Date: %D%  %T%
*************************************************************************/

#include <fxstd.h>

#ifdef SUNOS
#include <sys/time.h>
#else
#include <time.h>
#endif

#include "fxport.h" /* system and machine dependencies defined */

#include "fxtypes.h"

#include "fxisam.h"

#include "fxcon.h"  /* declare constants structures  */
#include "fxmacro.h"
#include "fxstruct.h"  /* declare cform structures  */

extern char *fxloadmsg();
extern long l_ptcalc();
extern int includeemail;

/*
#define TRACE
*/
#define ATTRLIST

/* File Partitions */

     /* Resident Partitions  */
#define P_MASTER     0
#define P_HEAD       1
#define P_IHEAD      2
#define P_FIELD      3
#define P_IFIELD     4
#define P_INDEX      5
#define P_RESTEXT    6
#define P_SYMTEXT    7
#define P_TEMPTEXT   8
     /* Transient Partiions  */
#define P_TFIELD     9
#define P_TIFIELD   10
#define P_TRANTEXT  11
#define P_TLITERAL  12
     /* Temporary Partitions  */
#define P_CFUNC     13

/* temp.tmp, tran.tmp, temp.pic */
#define P_TRAN      14
#define P_TEMP      15
#define P_TEMPPIC   16
#define MAXTMPFILE  17


/* Partition Classes  'ptClass' */
#define C_RESIDENT    1
#define C_TRANSIENT   2
#define C_DISK        3

/* used by ptcalc() to return various statistics about Partition files */
#define  SECSIZE      1
#define  TOTSIZE     2
#define  GRDSIZE     3
#define  SECNUM       4
#define  TOTNUM      5
#define  GRDNUM      6

#define MAXCMDSIZE 3000


#define MAXTAGHEAD   MAXHEADLIST 
#define MAXTAGFIELD 220 

typedef struct {
     char    thName[LENNAME];
     short   thLitnum;
     short   thLitsize;
     short   thTfindex;
     short   thTfnum;
   } TAGHEAD;


typedef struct {
     char    tfName[LENNAME];
     short   tfRow;
     short   tfCol;
     short   tfLength;
     short   tfThindex;
   } TAGFIELD;

typedef struct {
     short  *kaVariable;
     int   (*kaFunc)();
     short   kaPartition;
     char   *kaInclude;    /* include string  for range testing  */
     char   *kaLookup;     /* lookup table  */
   } KEYARG;

typedef struct {
     char   *khName;
     short   khType;
     char   *khArgbeg;
     short   khArgnum;
     char   *khArgend;
     KEYARG *khArgstr;
     int   (*khFunc)();
     short  *khFlagfld;
     long    khFlag;
   } KEYHEAD;


typedef struct {
     short  ptClass;
     short  ptType;
     FILE   *ptDesc;
     long   ptGrdsize;  /* accumualtive Total including HDHEAD values */
     long    ptTotsize;  /* accumualtive Total */
     long    ptSize;
     short   ptGrdnum;   /* accumulative count including HDHEAD values*/
     short   ptTotnum;  /* accumulative count */
     short   ptNum;
   } PARTITION;

#define MAXTBL 110 

typedef struct {
  char tlName[ LENNAME + 1];
  char tlAliasname[ LENNAME + 1];
  int  tlState;
  int  tlFldnum;
  int  tlSourceline;
  char tlSourcefile[30+1];
  int  tlPicOrder;     /* order fields are written to PIC file */
  } TABLELIST;


typedef struct {
    short  utStatic;  
    char  *utName;
    } USERTBL;
