/*
 * Include file: fxsql.h
 * Description:  Main include file for Sqlflex.
 *		 Contains defines, macros, and external references.
 */
#include <flex.h>
#include <fxsyscat.h>

#define NULLTYPE     -4
#define FXEOF	     -1
#define LINELEN	   2048
#define TAB	   '	'
#define NUMINSFLDS  400		/* number of fields INSERTable */
#define ERRFILE	   "sql.err"

#define TBLNAMSIZ    18
#define FLDNAMSIZ    18

/* SELECT/UPDATE statement modes:
 */
#define STANDALONE    0
#define INSERT	      1
#define UNLOAD	      2
#define UPDATE	      3
#define DELETE	      4

#define maxfunc(x,y)	(x > y ? x : y )
#define minfunc(x,y)	(x < y ? x : y )
#define rwputs(f,s)	rwwrite( f, s, (unsigned) strlen( s))
#define prmsg()		rwputs( 1, msgbuf)
#define prerr()		rwputs( 2, msgbuf)
#define stdputs(f,s)	write( f, s, (unsigned) strlen( s))

extern char s[];
extern char *p;
extern char spbuf[];
extern char *sp;
extern char msgbuf[];
extern FILE *fp_src;
extern long cmdfpos;
extern long lnpos;
extern short linenum;
extern short outwidth;
extern short dsplheader;
extern short interact;
extern short prwarn;
extern short firstwarn;
extern int n_source;
extern HDHEAD ghdhead;
extern DBHEAD *instable;
extern DBFIELD *modfields[];
extern short nummodflds;
extern char *fxuser;
extern int pid;
extern char sqlscript[];
extern char temptable[];

extern char *fgets();
extern long ftell();
extern char *sqlfileptr();
