/* isaccess.c */
int isaccess(int fd, int max);
static search(int *count, int fd, U32 low, U32 len, int max);
/* isamtest.c */
int main(int argc, char *argv[]);
int openisam(void);
int makeisam(void);
int closeisam(void);
int addrec(void);
int randel(void);
int ranupd(void);
int tick(void);
int check(int which);
int store(struct TestRec *p);
int load(struct TestRec *p, int i);
int Error(int l, char *p);
char *bdopts(int *c, char *v[]);
int i_ascg(char *b, int n);
int i_keys(struct keydesc *kp, int n);
int die(int l);
/* isassist.c */
int iSAentry(int fctn, int flag);
int iSAmod(int fctn, int flag);
int iSAexit(void);
int iSAfailed(void);
int iSAcurr(U32 n);
int iSAhere(char *block);
int iSApushprim(void);
int iSApopprim(void);
int iSAlocate(int num);
int iSAwcheck(char *recd);
int iSAmcheck(char *recd);
int iSAdcheck(void);
int iSAfix(void);
int iSAdflag(U32 recnum);
static int save(void);
/* isaudit.c */
int isaudit(int fd, char *name, int mode);
int iSAUrew(char *new, U32 num);
int iSAUwr(char *rec, U32 num);
int iSAUdel(U32 num);
static int aud_chk(void);
static int rd_aud(void);
static int wr_aud(void);
static int do_aud(char *type, char *recd, U32 num);
/* isborlok.c */
int isborlok(int fd, int mode, U32 len, U32 off);
/* isbuild.c */
int isbuild(char *name, int datlen, struct keydesc *key, int mode);
int isaddindex(int ifd, struct keydesc *key);
int isdelindex(int ifd, struct keydesc *key);
static int addkey(int fd, struct keydesc *key, int flag);
static int addnul(int fd);
static int deleted(U32 num);
static int namelen(char *s);
static int delfree(U32 recd);
static int deldefn(int num);
static int unopen(void);
/* isclean.c */
int iscleanup(void);
/* isclone.c */
int isclone(char *name, int oldfd, int mode, int index);
static int doAddIdx(int newfd, int oldfd, int index);
/* isclustr.c */
int iscluster(int oldfile, struct keydesc *key);
static int tempname(char *new, char *old);
/* iscopy.c */
int iscopy(int dest, int source, char *buffer, int flags);
/* isdata.c */
int isdata(int isfd, char *pad, long rec);
/* isdebug.c */
/* isdel.c */
int isdelcurr(int isfd);
int isdelete(int isfd, char *pad);
int isdelrec(int isfd, long recnum);
/* isdelchk.c */
int isdelchk(U32 recnum);
/* isdelete.c */
int iSidelete(void);
/* isdospid.c */
int isdospid(int fd);
/* isfilter.c */
int isfilter(void);
/* isgetblk.c */
U32 iSdget(void);
int iSdfree(U32 d);
U32 iSiget(void);
int iSifree(U32 n);
int iSiinit(char *block, int tree, int level);
static dexpand(void);
static iexpand(U32 n);
/* isgoto.c */
int isgoto(int isfd, long recnum);
/* isindex.c */
int isindex(int isfd, int index, int flag);
/* isinfo.c */
int isindexinfo(int isfd, struct keydesc *buf, int num);
static U32 count(void);
/* isinsert.c */
int iSinsert(char *key, U32 data, long dup);
static newroot(char *curkey, U32 data, int order, long dup);
static splitadd(char *key, U32 data, long dup, struct NewTemp *new);
static splithigh(char *key, U32 data, long dup, struct NewTemp *new);
static splitlow(char *key, U32 data, long dup, struct NewTemp *new);
/* iskeys.c */
int iSKload(U32 recnum);
int iSKpop(void);
U32 iSKinfo(void);
int iSKmake(char *data);
int iSKcopy(char *a, char *b);
int iSKcomp(U8 *a, U8 *b);
int iSK2comp(U8 *data, U8 *b);
int iSKlcmp(char *a, char *b, int len);
int iSKdcmp(char *a, long ad, char *b, long bd);
int iSKgoodkey(struct keydesc *key, int type, int datlen);
int iSKmeasure(char *kdsc);
int iSKmcmp(register U8 *p, register U8 *q, register int leng);
int iSKfirst(void);
int iSKlast(void);
int iSKprev(void);
int iSKnext(void);
int iSKnto(U8 *p, int prev);
int iSKncmp(U8 *key, int flag);
int iSKinit(void);
static int typlen(int type);
static int tokey(char **from, char **to, int type, int len);
static int keycomp(char *a, char *b, int type, int leng);
int iSKfixkey(void);
static int fixkey(void);
static int approx(char *key);
int dsppath(void);
int iSKdisplay(char *s, int l, FILE *d);
/* iskmod.c */
int iSKins(char *key, U32 data, long dupl);
int iSKcat(char *key, U32 data, long dupl);
int iSKfixmom(int force);
int iSKdel(void);
int iSKsplit(void);
static int makekey(char *fkd, char *pkd);
static int extract(char *start, char *end, char *new, int newlen);
static safecopy(char *dest, char *source, int len);
/* islast.c */
int issetlastrec(int fd, U32 rec);
int isgetlastrec(int fd, U32 *rec);
int islastrec(int fd, U32 *rec);
/* islink.c */
char *islink(char *path);
/* islock.c */
int iSLdget(U32 n, int mode);
int iSLiget(void);
int iSLiwget(void);
int iSLdfree(U32 n);
int iSLifree(void);
int iSLdgall(void);
int iSLdall(void);
int iSLdcheck(U32 n);
int iSLeget(int fd);
int iSLefree(int fd);
int iSLfget(int fd);
int iSLffree(int fd);
/* islocked.c */
int islocked(int isfd, long recnum);
/* ismachin.c */
int iSMlock(int fd, U32 loc, U32 len, int mode);
int iSMfree(int fd, U32 loc, U32 len);
/* ismask.c */
int issetmask(void);
int isgetmask(void);
/* ismemchk.c */
char *iSDBmalloc(int len);
int iSDBfree(char **pp);
int iSDBmemchk(char *ptr);
int iSDBmemuse(void);
/* isname.c */
char *isname(int isfd);
/* isnxtnum.c */
int isnxtnum(int isfd, long *recnum);
/* isopen.c */
int isopen(char *name, int mode);
int isclose(int isfd);
struct keydesc *iSOgetkd(struct dictinfo *dict, int nth, U32 keyloc);
static struct keydesc *getblank(void);
/* isopenfd.c */
int isopenfd(struct dictinfo *dict, char *name, int mode);
int is_open(char *path, int oflag, int mode);
/* isother.c */
int islock(int fd);
int isunlock(int fd);
int isrelease(int fd);
int isrelrec(int fd, long recd);
int isrelcurr(int fd);
char *isseekey(int fd);
static U32 isseecurr(int fd);
int isvclose(int count);
/* ispath.c */
int iSPpop(void);
int iSPunpop(void);
int iSPfree(void);
/* ispop.c */
int ispop(int isfd, int key, long rec);
/* ispsxlok.c */
int ispsxlok(int fd, int mode, long len, long loc);
/* ispthchk.c */
int iSDBpthchk(void);
/* ispure.c */
int ispuresize(void);
/* isread.c */
int isread2(int isfd, char *pad, int mode);
int isread(int isfd, char *pad, int mode);
/* isrew.c */
int isrewcurr(int isfd, char *pad);
int isrewrite(int isfd, char *pad);
int isrewrec(int isfd, long recnum, char *pad);
/* isrw.c */
int iSdread(int fd, char *pad, U32 recd);
int iSdwrite(int fd, char *pad, U32 recd);
int iSiread(int fd, char *pad, U32 block);
int iSiwrite(int fd, char *pad, U32 block);
int NDXread(char *pad, int len, U32 loc);
int NDXwrite(char *pad, int len, U32 loc);
int iSiflush(struct id_struct *which);
int iSiaflush(void);
int iSiclear(struct id_struct *which);
static struct is_bufstruct *get_active(U32 recd);
static struct is_bufstruct *get_mpty(U32 recd);
static to_mru(void);
static id_unlink(struct id_struct *which);
static int bufinit(void);
static push_blk(struct is_bufstruct *p);
static struct is_bufstruct *pop_blk(void);
/* issearch.c */
int iSsearch(char *srchkey, int mode);
int iSfirst(void);
int iSlast(void);
int iSprev(void);
int iSnext(void);
int iSrekey(int a, int sear);
int iSreset(void);
int iSassure(void);
int iSestablish(int mode);
int iSreestab(int k);
int iSlocate(int dupsearch);
static subsearch(char *k);
static searchkey(char *k);
static man_up(char *k);
static U32 transno(void);
/* isstart.c */
int isstart(int isfd, struct keydesc *key, int len, char *recd, int mode);
static int confirm(struct dictinfo *dict, struct Mkeydesc *key, int dir);
static empty(void);
/* istmpnam.c */
char *istempname(char *new);
static int newuniq(char *uniq);
int olduniq(char *uniq);
/* istrans.c */
/* isunique.c */
int issetunique(int fd, long id);
int isuniqueid(int fd, long *id);
/* isvirt.c */
/* iswrite.c */
int iswrite(int isfd, char *recd);
int iswrcurr(int isfd, char *recd);
/* isxtra.c */
int stchar(char *from, char *to, int len);
int ldchar(char *from, int len, char *to);
int ldint(char *s);
int stint(int i, char *d);
long ldlong(char *s);
int stlong(long l, char *d);
double ldfloat(char *p);
int stfloat(double d, char *p);
double lddbl(char *p);
int stdbl(double d, char *p);
int stfltnull(double d, char *p, short *n);
double ldfltnull(char *p, short *n);
int stdblnull(double d, char *p, short *n);
double lddblnull(char *p, short *n);
int ldmint(char *s);
int stmint(int i, char *p);
long ldmlong(char *s);
int stmlong(S32 l, char *p);
long ldDup(U8 *p);
int stDup(long d, U8 *p);
int iserase(char *name);
int isflush(int isfd);
int isrename(char *from, char *to);
