#include "flex.h"
#include "fxdball.h"
#include <math.h>
int debug = 0;


rtoday( pdate)
long *pdate;
{
   gettoday( pdate);
}

rjulmdy( julian, mdy, type)
long julian;
short mdy[3];
int type;
{
   int m, d, y;

   ntomdy( julian, &m, &d, &y);

   switch( type) {
      case EDATETYPE:
          mdy[0] = d;
          mdy[1] = m;
          mdy[2] = y;
          break;
      case YDATETYPE:
          mdy[0] = y;
          mdy[1] = m;
          mdy[2] = d;
          break;
      default:
          mdy[0] = m;
          mdy[1] = d;
          mdy[2] = y;
      }

}

rmdyjul( mdy, pjulian, type)
short mdy[3];
long *pjulian;
int type;
{
   int m, d, y;

   switch( type) {
      case EDATETYPE:
          d = mdy[0];
          m = mdy[1];
          y = mdy[2];
          break;
      case YDATETYPE:
          y = mdy[0];
          m = mdy[1];
          d = mdy[2];
          break;
      default:
          m = mdy[0];
          d = mdy[1];
          y = mdy[2];
      }
   mdyton( m, d, y, pjulian);

}


rradjust(left, right, filler)
char *left, *right;
char filler;
{
    char *p;

    p = right;
    while ( *p == ' ')
         p--;

    if (p != right) {
       /* move data to the right */
       while( p >= left) {
            *right-- = *p;
            *p-- = filler;
            }
       }

}

/* documentation:
   improper chars: unchanged.

/* documentation:
   improper chars: unchanged.
   new char '='. changes to minus if neg number.
   Useful for xxxx-  format for a negative number: #,###=

   One fudge factor in format, by popular request: 
   if $ at char 1 followed by 1 or more minuses,
    dbprusing leaves $ intact
   */
dbprusing(buf,format,val) 
char *buf,*format;
double val;
{
    char * strchr();
    int valisneg;
    double valmag;
    char *p, *pn;
    int dgtplaces, decplaces, decpnt;
    int lenformat, lennumbuf;
    int isdollar = 0, leftjust = 0, putdollar = 0, putsign = 0;
    char numbuf[50];


    lenformat = strlen(format);

    if (val < 0.0)
    {
        valisneg = 1;
        valmag = -val;
    }
    else
    {
        valisneg = 0;
        valmag = val;
    }

    /* create the ascii rounded number. Consult format to see
       how to round it */

    dgtplaces = decplaces = 0; decpnt = 0;
    for (p = format + lenformat - 1; p >= format; p--)
    {
        if (*p == '.' && ! decpnt)
        {
            decpnt = 1;
            decplaces = dgtplaces;
        }
        if (strchr("#$&*(-+<",*p)) /* all but ) = , and . */
            ++ dgtplaces;
        if (*p == '$')
            isdollar = 1;
        if (*p == '<')
            leftjust = 1;
    }

    sprintf(numbuf,"%.*f",decplaces,valmag);
    /* expected output: xxx.xxx or xxx. or xxx, never .xxx, always 0.xxx */
    if (debug) printf("before trim: %s ",numbuf);

    lennumbuf = strlen(numbuf);
    if (decplaces == 0) /* make this program portable: xxx. becomes xxx */
        if (numbuf[lennumbuf-1] == '.')
        numbuf[--lennumbuf] = '\0';
    if (debug) printf("after trim: %s \n",numbuf);

    strcpy(buf, format);

    for (p = buf+lenformat-1, pn = numbuf+lennumbuf-1;
        p >= buf; --p)
    {
        if (debug) printf("in loop buf: %s\n",buf);
        switch (*p)
        {
        case ')':
            *p = (valisneg ? ')' : ' ');
            break;
        case '=':
            *p = (valisneg ? '-' : ' ');
            break;
        case '.':
            /* leave as is: *p = '.'; */
            if (decplaces && decpnt)
            -- pn, decpnt = 0; /* decpnt unset for error avoidance*/
            break;

        case '#':
        case '$':
        case '&':
        case '*':
        case '(':
        case '-':
        case '+':
        case '<':
            if (pn >= numbuf) /* sig digits left */
            {
                *p = *pn--;
                break;
            }
            else
            {
PseudoComma:
                if (*p == '*')
                    ;
                else if (*p == '&')
                    *p = '0';
                else if (*p == '-' && *buf == '$') /* special */
                {
                    if (valisneg && ! putsign)
                        putsign = 1;
                    else 
                        *p = ' ';
                }
                else if (strchr("-+($",*p) && 
                    isdollar && !putdollar)
                {
                    *p = '$';
                    putdollar = 1;
                }
                else if ((*p == '-' || *p == '(') && 
                    valisneg && !putsign)
                {
                    /* *p = *p; */
                    putsign = 1;
                }
                else if (*p == '+' && !putsign)
                {
                    if (valisneg)
                        *p = '-'; /* else leave it + */
                    putsign = 1;
                }
                else
                    *p = ' ';
            }
            break;
            
        case ',':
            if (pn >= numbuf || p == buf)
            {
            /* leave as comma */
            break;
            }
            else
            {
            *p = *(p-1);
            goto PseudoComma;
            }
        }
    } /* end of for loop */

    if (debug) printf("after loop buf: %s\n",buf);

    if ( pn >= numbuf || (isdollar && ! putdollar))
    /* digits not done, $ not placed. field not big enough */
    {
        for (p = buf; *p; ++p)
            *p = '*';
        return;
    }
     
    if (leftjust)
    {
        int nspaces = 0;
        char c;

        for (p = buf; *p == ' '; ++p)
            ++nspaces;
        if (debug) printf("nspaces %d\n",nspaces);
        for (p = buf; c = *(p+nspaces); ++p)
            *p = c;
        if (debug) printf("in leftjust buf: %s\n",buf);
        for (;*p; ++p)
            *p = ' ';
        if (debug) printf("after leftjust buf: %s\n",buf);
    }
}
