
#include "flex.h"
#include "fxsyscat.h"
#include "fxdball.h"

/******  SQL commands used to create the 'tbref' file
    create table tbref
        (code          char(6),
         name          char(15)
         );
    create unique index tbrefkey
            on tbref   (code);
******/

typedef struct {
     char      code[6 + 1];
     char      name[15 + 1];
     } TBREF;

TBREF tbref;

/******  SQL commands used to create the 'tbref' file
    create table tbemp
        (code          char(4),
         lname         char(15),
         fname         char(10),
         hire_date     date,
         socno         char(13),
         raise_date    date,
         paymethod     integer,
         salary        money,
         commission    float
         );
   create unique index tbempkey
        on tbemp   (code);
******/

typedef struct {
         char  code[4 + 1];
         char  lname[15 + 1];
         char  fname[10 + 1];
         long  hire_date;
         char  socno[13 + 1];
         long  raise_date;
         long  paymethod;
         double salary;
         double commission;
     } TBEMP;

TBEMP tbemp;

struct dbview empview[] = 
    {
    {"code"},
    {"lname"},
    {"fname"},
    {"hire_date"},
    {"socno"}
    };

typedef struct {
         char  code[4 + 1];
         char  lname[15 + 1];
         char  fname[10 + 1];
         long  hire_date;
         char  socno[13 + 1];
     } EMPSTRUCT;

EMPSTRUCT empstruct;

main()
{
    int i, j, k;
    int rtn;
    int length;
    char code[20];
    int mode;
    short numflds, recsize, perms, type, len, idxtype;
    short ptype, plen, pperms;
    char partname[25];
    char fldname[25];
    char filename[25];

      if ( (rtn = dbselect( DBOPEN, "tbemp tbref")) != 0) {
         printf("Error dbselect(DBOPEN)  (%d)\r\n", rtn);
         exit(1);
         }


      if ( (rtn = dbfile( "tbemp", &numflds, &recsize, &perms)) != 0) {
         printf("Error dbfile()  (%d)\r\n", rtn);
         exit(1);
         }
      printf( "DBFILE() TEST\r\n");
      printf( "          tbemp numflds=%-3d,recsize=%-3d, perms=%d\r\n",
                numflds, recsize, perms);

      if ( (rtn = dbnfile( 0, filename, &numflds, &recsize, &perms)) != 0) {
         printf("Error dbfile()  (%d)\r\n", rtn);
         exit(1);
         }
      printf( "DBNFILE() TEST\r\n");
      printf( "        filename=%s, numflds=%-3d,recsize=%-3d, perms=%d\r\n",
                filename, numflds, recsize, perms);
      
      printf( "DBNFIELD(), DBINDEX(), and DBNCOMPOSITE() TEST\r\n");
      for (i= 0;;++i) {
          if ( (rtn = dbnfield(i,"tbemp",fldname,&type,&len,&perms)) != 0) {
             if (rtn == 6041)
                break;
             printf("Error dbnfield()  (%d)\r\n", rtn);
             exit(1);
             }

          if ( (rtn = dbindex("tbemp",fldname,&idxtype)) != 0) {
             if (rtn != 6007) {
                printf("Error dbnfield()  (%d)\r\n", rtn);
                exit(1);
                }
             }

          printf( "          %-19s  type=%-6d, len=%-3d, idxtype=%d, perms=%d\r\n",
                fldname, type, len, idxtype, perms);


          if (type == COMPOSTYPE) {
              for (k=0;  ; ++k) {
                  if ( (rtn = dbncomposite(k,"tbemp", fldname, partname, &ptype,&plen,&pperms)) != 0) {
                     if (rtn == 6044)
                        break;
                     printf("Error dbncomposite()  (%d)\r\n", rtn);
                     exit(1);
                     }
    
                 printf( "           COMPOSITE INDEX:compnum=%d, partname=%-19s, ptype=%-6d, plen=%-3d, perms=%d\r\n",
                    k, partname, ptype, plen, pperms);
    
                 }  /* end of for loop */
              } /* end of COMPOSTYPE test */

          }  /* end of outer for loop */

      if ( (rtn = dbselect( FILEOPEN, "tbemp")) != 0) {
         printf("Error dbselect(FILEOPEN) tbemp (%d)\r\n", rtn);
         exit(1);
         }

      if ( (rtn = dbstructview("tbemp", empview, 5)) != 0) {
         printf("Error dbstructview() (%d)\r\n", rtn);
         exit(1);
         }

      if ( (rtn = dbselfield( "tbemp", "code",  ACCKEYED)) != 0) {
         printf("Error dbselfield() tbemp (%d)\r\n", rtn);
         exit(1);
         }

      printf( "DBADD() TEST\r\n");
      strcpy( empstruct.code, "ADD");
      strcpy( empstruct.fname,"ADD fname");
      strcpy( empstruct.lname,"ADD lname");
      if ( (rtn = dbadd( "tbemp", &empstruct)) != 0) {
         printf("Error dbadd() (%d)\r\n", rtn);
         exit(1);
         }

      printf( "DBADD() TEST\r\n");
      strcpy( empstruct.code, "ADD2");
      strcpy( empstruct.fname,"ADD2 fname");
      strcpy( empstruct.lname,"ADD2 lname");
      if ( (rtn = dbadd( "tbemp", &empstruct)) != 0) {
         printf("Error dbadd() (%d)\r\n", rtn);
         exit(1);
         }

      strcpy( code, "GW"); /* Used to test searching modes for dbfind() */
      for (mode = FIRST+LOCK; ;mode = NEXT+LOCK) {

          if ( (rtn = dbfind( "tbemp", mode, code, &length, &empstruct)) != 0) {

             if (rtn == 6011)
                break;
             printf("Error dbfind() tbemp (%d)\r\n", rtn);
             exit(1);
             }
          if (strncmp( empstruct.code, "ADD", 3) == 0) {
              if ( (rtn = dbdelete( "tbemp")) != 0) {
                  printf("Error dbdelete() tbemp (%d)\r\n", rtn);
                  exit(1);
                  }
             }
            
          if (strncmp( empstruct.code, "GARY", 3) == 0) {
              strcpy( empstruct.lname, "Update");
              if ( (rtn = dbupdate( "tbemp", &empstruct)) != 0) {
                  printf("Error dbdelete() tbemp (%d)\r\n", rtn);
                  exit(1);
                  }
             }

          if ( (rtn = dbunlock( "tbemp")) != 0) {
             printf("Error dbunlock() tbemp (%d)\r\n", rtn);
             exit(1);
             }
         printf( "        TBEMP: code=%s, lname=%s\r\n", empstruct.code, empstruct.lname);
         }


      printf( "DBFIND() with composite key\r\n");
      if ( (rtn = dbselfield( "tbemp", "tbemp2key",  ACCKEYED)) != 0) {
         printf("Error dbselfield() tbemp (%d)\r\n", rtn);
         exit(1);
         }
      strcpy( empstruct.lname, "Pollard"); /* Used to test searching modes for dbfind() */
      strcpy( empstruct.code, "GARY"); /* Used to test searching modes for dbfind() */
      for (mode = FIRST+LOCK; ;mode = NEXT+LOCK) {

          if ( (rtn = dbfind( "tbemp", mode, code, &length, &empstruct)) != 0) {

             if (rtn == 6011)
                break;
             printf("Error dbfind() tbemp (%d)\r\n", rtn);
             exit(1);
             }

          if ( (rtn = dbunlock( "tbemp")) != 0) {
             printf("Error dbunlock() tbemp (%d)\r\n", rtn);
             exit(1);
             }
         printf( "        TBEMP: code=%s, lname=%s\r\n", empstruct.code, empstruct.lname);
         }
      if ( (rtn = dbselect( FILECLOSE, "tbemp")) != 0) {
         printf("Error dbselect(FILECLOSE) tbemp (%d)\r\n", rtn);
         exit(1);
         }


x_addindex:
      printf( "DBADDINDEX()\r\n");
      if ( (rtn = dbselect( FILEOPEN+EXCLUSIVE, "tbemp")) != 0) {
         printf("Error dbselect(FILEOPEN) tbemp (%d)\r\n", rtn);
         exit(1);
         }
      if ( (rtn = dbaddindex( "tbemp", "fname", 1)) != 0) {
         printf("Error dbaddindex() tbemp (%d)\r\n", rtn);
         exit(1);
         }
      if ( (rtn = dbselect( FILECLOSE, "tbemp")) != 0) {
         printf("Error dbselect(FILECLOSE) tbemp (%d)\r\n", rtn);
         exit(1);
         }



      if ( (rtn = dbselect( FILEOPEN, "tbemp")) != 0) {
         printf("Error dbselect(FILEOPEN) tbemp (%d)\r\n", rtn);
         exit(1);
         }
      if ( (rtn = dbstructview("tbemp", empview, 5)) != 0) {
         printf("Error dbstructview() (%d)\r\n", rtn);
         exit(1);
         }

      if ( (rtn = dbselfield( "tbemp", "fname", ACCKEYED)) != 0) {
         printf("Error dbselfield() tbemp (%d)\r\n", rtn);
         exit(1);
         }
      for (mode = FIRST; ;mode = NEXT) {

          if ( (rtn = dbfind( "tbemp", mode, code, &length, &empstruct)) != 0) {
             if (rtn == 6011)
                break;
             printf("Error dbfind() tbemp (%d)\r\n", rtn);
             exit(1);
             }
         printf( "        TBEMP: fname=%s, code=%s\r\n", 
                empstruct.fname, empstruct.code);
         }
      if ( (rtn = dbselect( FILECLOSE, "tbemp")) != 0) {
         printf("Error dbselect(FILECLOSE) tbemp (%d)\r\n", rtn);
         exit(1);
         }


x_delindex:
      printf( "DBDELINDEX()\r\n");
      if ( (rtn = dbselect( FILEOPEN+EXCLUSIVE, "tbemp")) != 0) {
         printf("Error dbselect(FILEOPEN) tbemp (%d)\r\n", rtn);
         exit(1);
         }
      if ( (rtn = dbdelindex( "tbemp", "fname")) != 0) {
         printf("Error dbaddindex() tbemp (%d)\r\n", rtn);
         exit(1);
         }
      if ( (rtn = dbselect( FILECLOSE, "tbemp")) != 0) {
         printf("Error dbselect(FILECLOSE) tbemp (%d)\r\n", rtn);
         exit(1);
         }


      if ( (rtn = dbselect( DBCLOSE, (char *)0)) != 0) {
         printf("Error dbselect(DBCLOSE) (%d)\r\n", rtn);
         exit(1);
         }


     exit(0);
}
