#include <stdio.h>
#include <flex.h>

typedef struct {
    char    colname[18+1];
    long    tabid;
    int     colno;
    int     coltype;
    int     collength;
} tsyscolumns;


typedef struct {
    char    tabname[18+1];
    char    owner[8+1];
    char    dirpath[64+1];
    long    tabid;
    int     rowsize;
    int     ncols;
    int     nindexes;
    long    nrows;
    long    created;
    long    version;
    char    tabtype[1+1];
    char    audpath[64+1];
} tsystables;


main(argc,argv)
	int argc;
	int *argv[];
{
	tsystables	tst;
	tsyscolumns	tsc;

	DBHEAD		*ast, *asc;

	long i = 0, a, b;
	FILE *fp, *t1,*t2;

	fmload("systables syscolumns");

	ast = getdhp("systables");
	asc = getdhp("syscolumns");

	fmstructview(ast, NULLCHAR, 0, (char *)&tst);
	fmstructview(asc, NULLCHAR, 0, (char *)&tsc);

	fmopen(ast, ISINPUT + ISMANULOCK);
	fmopen(asc, ISINPUT + ISMANULOCK);

	dclrrec ( ast );
	dclrrec ( asc );

	t1= fopen("temp1","w");
	t2= fopen("temp2","w");

	if ( fmstart ( ast, 0, 0, ISFIRST ) ) {
		fprintf(fp,"UNABLE TO START SYSTABLES\n");
		exit(1);
	}
	
	while ( fmread ( ast, ISNEXT ) == 0 )
	{
		strcompress(tst.tabname);

		if ( strcmp( tst.tabname, argv[1] ) == 0 ) {
			tsc.tabid = tst.tabid;
			tsc.colno = 0;
			strcpy(msgbuf,tst.tabname);
			
			fprintf(t1,"/************************* %s *************************/\n\n\n",msgbuf);

			fprintf(t1,"TABLES\n\t%s\nEND\n\n",tst.tabname);
			fprintf(t1,"\nSELECT\n\t%s( )\n\tEXTRACTALL\nEND\n\n", tst.tabname);
			fprintf(t1,"SCREEN f%s frame popup window(,)\n{\n\n",  tst.tabname);
			fprintf(t1,"   %s UPDATE SCREEN   [modemsg      ]\n\n",msgbuf);

			fprintf(t2,"\n\nATTRIBUTES\n\n");
			fprintf(t2,"modemsg         =\tdisplayonly type character, noupdate, noentry, reverse, retain;\n\n");


			if ( fmstart ( asc, getdip(asc,"column"), 0, ISGREAT ) ) {
				fprintf(t1,"UNABLE to START COLUMNS\n");
				exit(1);
			}  

			while ( fmread  ( asc, ISNEXT ) == 0 && tsc.tabid == tst.tabid ) {

				a =   0x00FF & tsc.collength;
				b = ( 0xFF00 & tsc.collength ) >> 8;

				strcompress(tsc.colname);

				switch (tsc.coltype) {
					case DECTYPE:
					case MONEYTYPE:
					case DOUBLETYPE:
                                                sprintf(msgbuf,"%-12.12s",tsc.colname);
                                                fprintf(t1,"[%s]\n",msgbuf);
						fprintf(t2,"%-15.15s =\t%s.%s;\n",msgbuf,tst.tabname,tsc.colname);
					break;					

					case FLOATTYPE:     
                                                sprintf(msgbuf,"%-6.6s",tsc.colname);
                                                fprintf(t1,"[%s]\n",msgbuf);
                                                fprintf(t2,"%-15.15s =\t%s.%s;\n",msgbuf,tst.tabname,tsc.colname);

					break;

					case INTTYPE:     
                                                sprintf(msgbuf,"%-5.5s",tsc.colname);
                                                fprintf(t1,"[%s]\n",msgbuf);
                                                fprintf(t2,"%-15.15s =\t%s.%s;\n",msgbuf,tst.tabname,tsc.colname);
					break;

					case LONGTYPE:
					case SERIALTYPE:
					case DATETYPE:
					case TIMETYPE:
					case MTIMETYPE:   
						sprintf(msgbuf,"%-8.8s",tsc.colname);
						fprintf(t1,"[%s]\n",msgbuf);
                                                fprintf(t2,"%-15.15s =\t%s.%s;\n",msgbuf,tst.tabname,tsc.colname);
					break;

					case CHARTYPE: case BINTYPE:
                                                sprintf(msgbuf,"%- *.*s",a,a,tsc.colname);
                                                fprintf(t1,"[%s]\n",msgbuf);
                                                fprintf(t2,"%-15.15s =\t%s.%s;\n",msgbuf,tst.tabname,tsc.colname);
					break;
		 		}
			} /* while column */

			strcompress(tst.tabname);
			fprintf(t1,"}\n\nEND\n");
			fprintf(t2,"\nEND\n");

			break;			

		} /* if found table */
	}    /* while */

	fclose(t1);
	fclose(t2);

	sprintf(msgbuf,"cat temp1 temp2 > %s.flx",argv[1]);
	system(msgbuf);
	system("rm temp1 temp2");
}
