/* genstr.c  by Kevin Greer   Sep. 23, 1992 */


#include <stdio.h>
#include <flex.h>

typedef struct {
    char    colname[18+1];
    long    tabid;
    int     colno;
    int     coltype;
    int     collength;
} tsyscolumns;


typedef struct {
    char    tabname[18+1];
    char    owner[8+1];
    char    dirpath[64+1];
    long    tabid;
    int     rowsize;
    int     ncols;
    int     nindexes;
    long    nrows;
    long    created;
    long    version;
    char    tabtype[1+1];
    char    audpath[64+1];
} tsystables;


main(argc,argv)
	int argc;
	int *argv[];
{
	tsystables	tst;
	tsyscolumns	tsc;

	DBHEAD		*ast, *asc;

	long i = 0, a, b;
	FILE *fp;

	fmload("systables syscolumns");

	ast = getdhp("systables");
	asc = getdhp("syscolumns");

	fmstructview(ast, NULLCHAR, 0, (char *)&tst);
	fmstructview(asc, NULLCHAR, 0, (char *)&tsc);

	fmopen(ast, ISINPUT + ISMANULOCK);
	fmopen(asc, ISINPUT + ISMANULOCK);

	dclrrec ( ast );
	dclrrec ( asc );

	sprintf(msgbuf,"%s.h",argv[1]);
	fp = fopen(msgbuf,"w");
	
	if ( fmstart ( ast, 0, 0, ISFIRST ) ) {
		fprintf(fp,"UNABLE TO START SYSTABLES\n");
		exit(1);
	}
	
	while ( fmread ( ast, ISNEXT ) == 0 )
	{
		strcompress(tst.tabname);

		if ( strcmp( tst.tabname, argv[1] ) == 0 ) {
			tsc.tabid = tst.tabid;
			tsc.colno = 0;

			fprintf(fp,"\ntypedef struct {\n");

			if ( fmstart ( asc, getdip(asc,"column"), 0, ISGREAT ) ) {
				fprintf(fp,"UNABLE to START COLUMNS\n");
				exit(1);
			}  

			while ( fmread  ( asc, ISNEXT ) == 0 && tsc.tabid == tst.tabid ) {

				a =   0x00FF & tsc.collength;
				b = ( 0xFF00 & tsc.collength ) >> 8;

				strcompress(tsc.colname);

				switch (tsc.coltype) {
					case DECTYPE:
					case MONEYTYPE:
					case DOUBLETYPE:
						fprintf(fp,"    double  %s;\n",tsc.colname);
					break;					

					case FLOATTYPE:     
						fprintf(fp,"    float   %s;\n",tsc.colname);
					break;

					case INTTYPE:     
						fprintf(fp,"    int     %s;\n",tsc.colname);
					break;

					case LONGTYPE:
					case SERIALTYPE:
					case DATETYPE:
					case TIMETYPE:
					case MTIMETYPE:   
						fprintf(fp,"    long    %s;\n",tsc.colname);
					break;

					case CHARTYPE: case BINTYPE:
						fprintf(fp,"    char    %s[%d+1];\n",tsc.colname,a);
					break;
		 		}
			} /* while column */

			strcompress(tst.tabname);
			fprintf(fp,"} t%s;\n\n",tst.tabname);
			
			break;			

		} /* if found table */
	}    /* while */

	fclose(fp);
}


