
/******************************************************************************
 *
 *	%Z%%M%		%I% (arms3M) %G% %U%
 *
 *	%P%
 *
 *	%Q%
 *	%Y%
 *
 *	Copyright (c) 1986, Minnesota Mining & Manufacturing Company
 *	All Rights Reserved.
 *
 *	Auto Repair Management Systems/3M
 *
 *	251-2E-12 3M Center
 *	Saint Paul, MN  55144-1000
 *
 *      1241 East Hillsdale Boulevard 
 *      Foster City, CA  94404-1241  
 *
 ******************************************************************************
 */




/*F
 *	Name: getstr.c  - traps keyboard sequences and stores them in a string.
 *
 *	Class: F 
 *
 *      Author:  Gerard Menicucci
 *
 *	Description: This routine is responsible for screen control.
 *
 *	Returns:
 *
 *	Warnings:
 *
 */
     
#include <stdio.h>
#include <errno.h>
 
#ifdef UNIX
#include <sys/types.h>
#include <sys/ioctl.h>
#include <termio.h>
#include <signal.h>
#include <fcntl.h>
#endif
 
#include "dclcon.h"
#include "dclcrt.h"

extern int readport;
extern int writport;
void sigalarm();
static alarmflag = NO;

static struct termio oldtty;
 


getstr( keystr)
char *keystr;
{
    int i, j;
    int readflag;
    char keyhit;


    setsignal();


    for (i = 0;;)  {
        keyhit = 0;
        alarmflag = NO;
        alarm(1);

        if (  0 > (readflag = read(readport, &keyhit, 1)) ) {
           /*
	   printf("Libsys2 Read error: errno %d\r\n", errno);
           */
           }
        alarm(0);

        /*  Diagnostics message
        printf( "%d. %d\r\n", i, keyhit); fflush( stdout);
        */

        if (alarmflag == YES && i > 0)  
           break;

        if ( 0 > readflag) 
           continue;

        keystr[i] = keyhit;
        ++i;

        }  /* end of for loop  */


    keystr[i] = 0;  /* null terminate  */

/*
    for (j = 0; j < 6 && keystr[j] > 0; ++j)
        printf( "%4d", keystr[j]);

    printf( "\r\n"); fflush( stdout);
*/

}



/*
 
x_fldattr(termvar, type, row, startcol, lastcol)
TERMVAR *termvar;
int type;
int row, startcol, lastcol;
{
    int key;

    switch(type) {
        case BRACKET:
        case NORMAL:
             x_gotoxy(row, startcol, termvar);
             printf("%s", termvar->tv_crtseq[ type]);
             break; 
        case REVERSE:
        case REVBLINK:
        case BLINK:
        case UNDERLINE:
             if ( termvar->tv_crtseq[ type][0] == 0) {
                 printf( "\r\n\r\n This attribute is not set\r\n\r\n");    
                 break;
                 }
             x_gotoxy(row, lastcol, termvar);
             printf("%s", termvar->tv_crtseq[ type + 1]);
             x_gotoxy(row, startcol, termvar);
             printf("%s", termvar->tv_crtseq[ type]);
             break; 
        }  

}
 
*/ 

 

/*


int x_crtioctl()
{
    struct termio tty;

    if ((crtport = open("/dev/tty", O_RDWR)) == -1) {
            fprintf(stderr, "crtioctl(): can't open /dev/tty\n");
            return(-1);
            }
 
    ioctl(crtport, TCGETA, &tty);
    ioctl(crtport, TCGETA, &oldtty);
 

    tty.c_iflag = (tty.c_iflag & (~ 077)) | (IGNPAR | IXON);
    tty.c_oflag = 0;
    tty.c_cflag = (tty.c_cflag & ~ (PARENB));
    tty.c_lflag = ISIG;
    tty.c_cc[4] = 01;
    tty.c_cc[5] = 0;
 
    ioctl(crtport, TCSETA, &tty);

    return(crtport);
}



int x_endcrt()
{
    if (crtport == -1)
	return(-1);

    ioctl(port, TCFLSH, 2);
    ioctl(port, TCSETA, &oldtty);

    close(port);


    return(port);
}
*/ 



setsignal()  /* set signals */
{
    signal( SIGALRM, sigalarm);
}




sigalarm( signo)  /* routine executed when alarm goes off  */
int signo;
{
        alarmflag = YES;	
	signal( SIGALRM, sigalarm);
}


/*
x_gotoxy(row, col, termvar )
int row, col;
TERMVAR *termvar;
{
    int nbytes=0;
    char pos[15];

    if ( termvar->tv_crtseq[0][0] == '1')  
        printf("%s%d%s%d%s", 
                   termvar->tv_crtseq[ C_LEAD],  
                   row + (termvar->tv_crtseq[ C_ROWSET][0] & 0xff), 
                   termvar->tv_crtseq[ C_SEPAR],  
                   col + (termvar->tv_crtseq[ C_COLSET][0] & 0xff),
                   termvar->tv_crtseq[ C_TRAIL]);
    else
        printf("%s%c%c", 
                   termvar->tv_crtseq[ C_LEAD],  
                   row + (termvar->tv_crtseq[ C_ROWSET][0] & 0xff), 
                   col + (termvar->tv_crtseq[ C_COLSET][0] & 0xff));

}
 
*/

