/************************************************************************
*                       - INFOFLEX System -
* This source code is CONFIDENTIAL and PROPRIETARY to CUSTOMWARE COMPUTING,
* INC. (CWC). The information contained herein may not be used, copied or
* disclosed in whole or in part except as permitted by written agreement
* signed by an officer of CWC.
*
* COPYRIGHT (c) 1986 CUSTOMWARE COMPUTING, INC., BURLINGAME, CALIFORNIA.
* ALL RIGHTS RESERVED.
*
* Version: %V%  %R%
* Date: %D%  %T%
*************************************************************************/

/*F
 *    Name: Assign ACTION key via keyboard.
 *
 *    Class: F
 *
 *    Author:  Gerard Menicucci
 *
 *    Description:
 *
 *    Returns:
 *
 *    Warnings:
 *
 */

#include "termflex.h"

extern TERMTBL acttbl[];
extern char *actptr[];

pmtkbaction( termvar)
TERMVAR *termvar;
{
    int i, j, k, l;
    int labelno;
    char keystr[ 100];
    char line[ 100];
    int firstime;
    int firstseq;
    int error;
    int length;
    int start;

    printf( "\r\n\r\nASSIGN ACTION KEY via Keyboard\r\n\r\n");


for (;;) {
     printf( "Enter #=Action Key, Q=Quit >");

     termgetline( line, sizeof(line), stdin);

     if (line[0] == 'Q' || line[0] == 'q')
        return(0);

     i = atoi( line);

     if (0 > i) {
         printf("\r\n\r\nInvalid number --- try again\r\n\r\n");
         fflush( stdout);
         continue;
         }

     if ( i < 1 ||  i > termvar->tv_nactseq) {
         printf("\r\n\r\nNumber is not within valid range --- try again\r\n\r\n");
         fflush( stdout);
         continue;
         }

      break;
      }   /* end of for loop   */


    printf("\r\n\r\n");
    printf("\tWhile defining Action keys you may enter any one of the\r\n");
    printf("\tfollowing commands: 0=Clear, P=Previous, N=Next, Q=Quit.\r\n");
    printf("\r\n\r\n");
    fflush( stdout);


   i--;
   for (; i < termvar->tv_nactseq;) {
      printf( "\r\n");
      printf( "%30.30s %2d ",  acttbl[i].tm_prompt, i+1);
      printf("<");
      for (j = 0; j < ACTSIZE; ++j) {
         if (termvar->tv_actseq[i][j] == '\0')
             break;
         printf( "%4d", termvar->tv_actseq[i][j]);
         }
      printf(">: ");
      fflush( stdout);

      tmgetstr( keystr);

      keystr[ ACTSIZE - 1] = 0; /* null terminate keystring */

      if (keystr[0] > 32) {
         if (keystr[0] == '0') {

            for(k=0; k < ACTSIZE; ++k) {
                keystr[k] = 0;
                termvar->tv_actseq[i][k] = 0;
                }
            ++i;
            continue;
            }

         if (keystr[0] == 'Q' || keystr[0] == 'q')
            break;
         if (keystr[0] == 'N' || keystr[0] == 'n') {
            ++i;
            continue;
            }
         if (keystr[0] == 'P' || keystr[0] == 'p') {
            if (i > 0) --i;
            continue;
            }

         printf("\r\n\r\nInvalid Action key --- try again\r\n\r\n");
         fflush( stdout);
         continue;
         }


      /* special case for ESCAPE key to get double escape  */
      if (termvar->tv_actseq[i][0] == 27 && (strlen( keystr) < 2)) {
          /* create double escape */
         strcpy( &termvar->tv_actseq[i][0], keystr);
         strcat( &termvar->tv_actseq[i][0], keystr);
         strcpy( keystr, &termvar->tv_actseq[i][0]);
         }
     else
         strcpy( &termvar->tv_actseq[i][0], keystr);


      for (j = 0; j < 6 && keystr[j] > 0; ++j)
         printf( "%4d", keystr[j]);

      ++i;
      }


/* look for duplicate key sequences  */

#ifdef DEBUG
   actsort( actptr, termvar->tv_nactseq, 2);
   error = NO;


   firstime = YES;
   for ( i = 0; i < termvar->tv_nactseq &&
               0 ==  actptr[i][0]; ++i) {
      if (firstime == YES) {
          firstime = NO;
          error = YES;
          printf( "\r\n\r\n\r\n");
          printf( "Warning: The following ACTION keys have NOT been");
          printf( " assigned.\r\n\r\n");
          }

      for ( l = 0; l < termvar->tv_nactseq &&
           actptr[i][0] != acttbl[l].tm_tagno ; ++l);
      printf("&&  %s  ", acttbl[l].tm_prompt);

      }


   start  = i;


   firstime = YES;
   firstseq = YES;
   for ( i = start, j=start + 1 ; j < termvar->tv_nactseq; ++j) {

           if (0 != strcmp( actptr[i], actptr[j] )) {
                 firstseq = YES;
                 i = j;
                 continue;
                 }

           if (firstime == YES) {
              firstime = NO;
              error = YES;
              printf( "\r\n\r\n\r\n");
              printf( "Warning: The following ACTION keys have been assigned");
              printf( " the same key sequence.\r\n");
              }

           /* print key seqeunce only once  */
           if ( firstseq == YES) {
               firstseq = NO;
               printf("\r\n");
               for (k = 2; k < (ACTSIZE - 2); ++k)
                   printf( "%4d", actptr[i][k]);
               printf(" | ");

               for ( l = 0; l < termvar->tv_nactseq &&
                     actptr[i][0] != acttbl[l].tm_tagno ; ++l);


               printf(" %s ", acttbl[l].tm_prompt);
/*
               printf(" %s l=%d, tag=%d", acttbl[l].tm_prompt, l, actptr[i][0];
*/
               }


           for ( l = 0; l < termvar->tv_nactseq &&
                     actptr[j][0] !=  acttbl[l].tm_tagno ; ++l);

           printf("&&  %s ", acttbl[l].tm_prompt);

/*
           printf(" %s l=%d, tag=%d", acttbl[l].tm_prompt, l, actptr[j][0]);
*/
           }  /* end of j for loop  */



   firstime = YES;
   firstseq = YES;
   for ( i=start, j=start+1 ; j < termvar->tv_nactseq; ++j) {

       /* get length of sequence  */
         /* length includes NULL byte  */
       for (length = 1, k = 0; k < ACTSIZE && actptr[i][k] != 0;
              ++length, ++k)


       /* different sequence then skip it  */
       if ( 0 != strncmp(actptr[i], actptr[j], length)){
           i = j;
           continue;
           }


       /* same sequence then skip it  */
       if ( 0 == actptr[j][ length-1 ]) {
          i = j;
          continue;
          }


       if (firstime == YES) {
          firstime = NO;
          error = YES;
          printf( "\r\n\r\n\r\n");
          printf( "Serious Warning: The following ACTION key sequences conflict.");
          printf( "\r\n      Note: An ACTION key sequence may NOT be a Leadin");
          printf( "\r\n            for another ACTION key sequence.\r\n");
          }

       printf("\r\n");
       for (k = 0; k < ACTSIZE; ++k)
           printf( "%4d", actptr[i][k]);
       printf(" | ");
       for ( l = 0; l < termvar->tv_nactseq &&
             actptr[i][0] != acttbl[l].tm_tagno ; ++l);
       printf(" %s ", acttbl[l].tm_prompt);


       printf(" | ");
       for (k = 0; k < ACTSIZE; ++k)
           printf( "%4d", actptr[j][k]);
       printf(" | ");

       for ( l = 0; l < termvar->tv_nactseq &&
             actptr[j][0] != acttbl[l].tm_tagno ; ++l);

       printf(" %s ", acttbl[l].tm_prompt);



       }  /* end of j for loop  */



   if ( error == YES) {
       printf("\r\n\r\nPress any key to return to the menu...");
       termgetline( line, sizeof(line), stdin);
       }

#endif

}


