/************************************************************************
*                       - INFOFLEX System -
* This source code is CONFIDENTIAL and PROPRIETARY to CUSTOMWARE COMPUTING,
* INC. (CWC). The information contained herein may not be used, copied or
* disclosed in whole or in part except as permitted by written agreement
* signed by an officer of CWC.
*
* COPYRIGHT (c) 1986 CUSTOMWARE COMPUTING, INC., BURLINGAME, CALIFORNIA.
* ALL RIGHTS RESERVED.
*
* Version: %V%  %R%
* Date: %D%  %T%
*************************************************************************/

#include "termflex.h"
#define MAXCRT 100
#define MAXACT 50

TERMTBL crttbl[ MAXCRT];
char crtseq[ MAXCRT][ CRTSIZE];
int n_crttbl;

TERMTBL acttbl[ MAXACT];
char actseq[ MAXACT][ ACTSIZE];
int n_acttbl;

extern int cwvar3();

char asctermpath[ 256];
char bintermpath[ 256];

char cwtermpath[ 256];

#ifdef UniFLEX
    extern
#endif

TERMVAR termvar;

main()
{
     extern char *getenv();
     char *fxdir;

     initable( &termvar);

     cwtermpath[0] = '\0';
     if ( NULL == (fxdir = getenv( FXDIR) ) ) {
        printf( "\n\r\n\rFXDIR environment variable must be set");
        exit(0);
        }

     strcpy( cwtermpath, fxdir);
     strcat( cwtermpath, PATHSLASH);
     strcat( cwtermpath, "dev");

     printf("\r\n\r\n\r\n\r\n\r\n\r\n\r\n");

     if ( QUIT == menuterm() )
        return(0);

     readxxx( &termvar, asctermpath);
     wrascii( &termvar, asctermpath);

}


menu( termvar)
TERMVAR *termvar;
{
   char c;
   int dbreak = NO;
   char line[ 90];

   for ( ;dbreak==NO;) {

       printf("\r\n\r\n\r\n\r\n");
       printf(" T E R M I N A L    S U P P O R T   M E N U (%s)\r\n", cwtermpath);
       printf(" ---------------------------------------------------------\n\n");

       printf("     1.  Assign CRT & ACTION KEY Settings\n");
       printf("     2.  Assign ACTION KEYS Settings via Keyboard.\n");
       printf("     3.  Display CRT Settings.\n");
       printf("     4.  Display ACTION KEY Settings.\n");
       printf("     5.  Print Settings.\n");
       printf("     6.  Test Settings.\n");
       printf("     7.  Save Settings.\n");
       printf("     8.  Save & Install Settings to %s.\n", cwtermpath);
       printf("     9.  Load Settings from TERMCAP file.\n");
       printf("     Q.  Quit.\n");
       printf("\n\n");
       printf("         Select Menu Option # ");

       termgetline( line, sizeof(line), stdin);
       c = line[0];
       switch(c) {
          case '1':
             pmtseq( termvar);
             break;
          case '2':
             pmtkbaction( termvar);
             break;
          case '3':
             prcrtseq( termvar, DISPLAY);
             break;
          case '4':
             practseq( termvar, DISPLAY);
             break;
          case '5':
             sprintf( line, "pr %s | %s", asctermpath, LPCOMMAND);
             system(line);
             break;
          case '6':
             testterm( termvar);
             break;
          case '7':
             wrascii( termvar, asctermpath);
             writeterm( termvar);
             break;
          case '8':
             wrascii( termvar, asctermpath);
             writeterm( termvar);
#ifdef UNIX
             sprintf( line, "cp %s %s", bintermpath, cwtermpath);
#endif
#ifdef MSDOS
             sprintf( line, "copy %s %s", bintermpath, cwtermpath);
#endif
             system(line);
             break;
          case '9':
             /* use getcap() from clif
             readcap( termvar);
              */
             break;
          case 'B':
             readascii( termvar, asctermpath);
             break;
          case 'b':
          case 'e':
          case 'E':
          case 'Q':
          case 'q':
             dbreak = YES;
             break;
          default:
             printf( "Bad entry --- Try Again");

          }
      }


    return( 0);
}




menuterm()
{
    FILE      * fp;
    char line[60];
    int    i, cc;
    char termname[20];
    extern char *getword();

    if ((fp = fopen("termflex.dir", "r")) == NULL) {
        printf("%s: can't open termflex.dir\n");
        return(QUIT);
    }

    printf("\r\n\r\nSELECT TERMINAL TYPE\r\n\r\n");

    for (i=1; termgetline(line, sizeof(line), fp) != 0; ++i)
        printf("%2d. %-30s\n", i, line);

    printf("\nEnter terminal type: ");
    termgetline(line, sizeof( line), stdin);
    cc = atoi(line);

    if (cc >= 1 && cc <= i) {
        rewind( fp);
        for (i=1; termgetline(line, sizeof(line), fp) != 0 && i < cc; ++i);
        getword( termname, line);
        strcompress( termname);
        strcpy(bintermpath, termname);
        strcpy(asctermpath, termname);
        strcat(asctermpath, ".asc");
        }
    else {
        printf("Invalid Entry\n");
        return( QUIT);
        }


    fclose(fp);

    return( 0);
}





clrseq( termvar, opcode)
TERMVAR *termvar;
int opcode;
{
      int i;

     memset( (char *)*termvar->tv_actseq, '\0', (termvar->tv_nactseq * ACTSIZE));
     memset( (char *)*termvar->tv_crtseq, '\0', (termvar->tv_ncrtseq * CRTSIZE));

}



static int initable( termvar)
TERMVAR *termvar;
{
     int i;
     extern char *calloc();

     memset( (char *)termvar, '\0', sizeof(TERMVAR));



     /*  K E Y   S E Q U E N C E S   */
     n_acttbl = MAXACT;
     loadtbl( "termflex.act", acttbl, &n_acttbl);
     termvar->tv_nactseq = n_acttbl; /* assign address of first pointer */
     if ( NULL == ( termvar->tv_actseq = (char **)
                    calloc( termvar->tv_nactseq, sizeof( char *) ) ) ) {
        printf( "Insufficient Memeory");
        exit(1);
        }

     /* initialize array of pointers  */
     for ( i = 0; i < termvar->tv_nactseq; ++i)
         termvar->tv_actseq[i] = actseq[i];



     /*  C R T   C O N T R O L   S E Q U E N C E S    */
     n_crttbl = MAXCRT;
     loadtbl( "termflex.crt", crttbl, &n_crttbl);
     termvar->tv_ncrtseq  = n_crttbl;/* assign address of first pointer */
     if ( NULL == ( termvar->tv_crtseq = (char **)
                    calloc( termvar->tv_ncrtseq, sizeof( char *) ) ) ) {
        printf( "Insufficient Memeory");
        exit(1);
        }

     /* initialize array of pointers  */
     for ( i = 0; i < termvar->tv_ncrtseq; ++i)
         termvar->tv_crtseq[i] = crtseq[i];

     clrseq( termvar, NULL);


}



writeterm(termvar)
TERMVAR *termvar;
{
    TERMHDR termhdr;
    int i, j, fd, nbytes;
        int nalloc, crtnalloc, actnalloc;
        char line[80];


    if (bintermpath == NULL) {
           printf( "Could not open file %s", bintermpath);
           return -1;
           }

    if ( -1 == (fd = open( bintermpath,
                 (O_WRONLY | O_TRUNC | O_CREAT | O_BINARY), MODE_RAW)  ) ) {
           printf( "Could not open file %s", bintermpath);
           return -1;
           }

     /* set-up TERMINAL HEADER  */
    memset((char *)&termhdr, '\0', sizeof(TERMHDR));

    x_shtobuf(termhdr.th_magic, KH_MAGIC);
    strcpy(termhdr.th_version, "VERSION 1.00");
    strncpy(termhdr.th_termname, bintermpath, sizeof( termhdr.th_termname) - 1);

    x_shtobuf(termhdr.th_nactseq, termvar->tv_nactseq);
    x_shtobuf(termhdr.th_ncrtseq, termvar->tv_ncrtseq);

        /* set allocation count for CRT SEQUENCES */
    crtnalloc = 0;
    for (i = 0; i < termvar->tv_ncrtseq; ++i) {
        crtnalloc += strlen(termvar->tv_crtseq[i]) + 1;
            }
    x_shtobuf(termhdr.th_crtnalloc, crtnalloc);

        /* set allocation count for ACTION SEQUENCES */
    actnalloc = 0;
    for (i = 0; i < termvar->tv_nactseq; ++i) {
        actnalloc += strlen(termvar->tv_actseq[i]) + 1;
            }
    x_shtobuf(termhdr.th_actnalloc, actnalloc);



      /* write out TERMINAL HEADER  */
    nbytes = write(fd, (char *)&termhdr, sizeof(TERMHDR));
        if (nbytes < sizeof(TERMHDR)) {
                printf( "Could not write TERMINAL Header");
                fflush( stdout);
        return -1;
                }


      /* write out CRT SEQUENCES */
         /* write each piece because efficiency not an issue here  */
    for (i = 0; i < termvar->tv_ncrtseq; ++i) {
        nalloc = strlen(termvar->tv_crtseq[i]) + 1;
                nbytes = write( fd, termvar->tv_crtseq[i], nalloc);
                if (nbytes < nalloc) {
                    printf( "Could not write CRT SEQUENCES");
                    fflush( stdout);
                return -1;
                    }

/*
                printf( "%3d.  %-30.30s  ",
                      i+1,  crttbl[i].tm_prompt);
                for (j = 0; j < nalloc; ++j)
                    printf( "%4d", termvar->tv_crtseq[i][j] );
                printf( "\n");
*/
            }


      /* write out ACTION KEY SEQUENCES */
         /* write each piece because efficiency not an issue here  */
    for (i = 0; i < termvar->tv_nactseq; ++i) {
        nalloc = strlen(termvar->tv_actseq[i]) + 1;
                nbytes = write( fd, termvar->tv_actseq[i], nalloc);
                if (nbytes < nalloc) {
                    printf( "Could not write ACTION SEQUENCES");
                    fflush( stdout);
                return -1;
                    }

/*
                printf( "%3d.  %-30.30s  ",
                      i+1,  acttbl[i].tm_prompt);
                for (j = 0; j < nalloc; ++j)
                    printf( "%4d", termvar->tv_actseq[i][j] );
                printf( "\n");
*/
            }


        printf( "\r\n\r\n\r\n S A V E     S U M M A R Y \n");

        printf( " header byte count = %d\n", sizeof(TERMHDR));
        printf( " crt byte count    = %d\n", crtnalloc);
        printf( " action byte count = %d\n", actnalloc);
        printf("\r\n\r\nPress RETURN key to continue...");
        termgetline(  line, sizeof line, stdin);
        printf("\r\n\r\n\r\n");
        fflush( stdout);

    close(fd);
    return 0;
}




pmtseq( termvar)
TERMVAR *termvar;
{
    char command[ 100];
    char *editor;
    extern char *getenv();

        wrascii( termvar, "ascterm.tmp");

        if ( NULL == ( editor = getenv( FXEDIT) ) )
#ifdef UNIX
            strcpy( command, "vi");
#endif

#ifdef MSDOS
            strcpy( command, "e");
#endif
        else
            strcpy( command, editor);

        strcat( command, " ascterm.tmp");

        if ( 0 != system( command) ) {
             printf( "error calling editor");
             fflush( stdout);
             }

        readascii( termvar, "ascterm.tmp");

}



prcrtseq( termvar, mode)
TERMVAR *termvar;
int mode;
{

   printf("\n\n");
   printf(" C R T   C O N T R O L   S E Q U E N C E S (%d)\n", termvar->tv_ncrtseq);
   printseq(  crttbl, termvar->tv_crtseq, termvar->tv_ncrtseq );

}

practseq( termvar, mode)
TERMVAR *termvar;
int mode;
{

   printf("\n\n");
   printf(" A C T I O N  /  F U N C T I O N    K E Y S (%d) \n", termvar->tv_nactseq);
   printseq(  acttbl, termvar->tv_actseq, termvar->tv_nactseq );

}


wrascii( termvar, termpath)
TERMVAR *termvar;
char *termpath;
{
    FILE *fp;

    if ( NULL == (fp = fopen( termpath, "w"))) {
        printf( "%s file could not be opened", termpath);
        return( -1);
        }

   writecap(fp, crttbl, termvar->tv_crtseq, termvar->tv_ncrtseq, CRTSIZE);
   writecap(fp, acttbl, termvar->tv_actseq, termvar->tv_nactseq, ACTSIZE);

    fclose( fp);

}


readxxx( termvar, termpath)
TERMVAR *termvar;
char *termpath;
{
    FILE *fp;

    if ( NULL == (fp = fopen( termpath, "r"))) {
        printf( "%s file does not exist", termpath);
        return( -1);
        }

   clrseq( termvar, NULL);
   readseq(fp, crttbl, termvar->tv_crtseq, termvar->tv_ncrtseq, CRTSIZE);
   readseq(fp, acttbl, termvar->tv_actseq, termvar->tv_nactseq, ACTSIZE);


   fclose( fp);



}
readascii( termvar, termpath)
TERMVAR *termvar;
char *termpath;
{
    FILE *fp;

    if ( NULL == (fp = fopen( termpath, "r"))) {
        printf( "%s file does not exist", termpath);
        return( -1);
        }

   clrseq( termvar, NULL);
   readcap(fp, crttbl, termvar->tv_crtseq, termvar->tv_ncrtseq, CRTSIZE);
   readcap(fp, acttbl, termvar->tv_actseq, termvar->tv_nactseq, ACTSIZE);


   fclose( fp);



}
