/************************************************************************
*                       - INFOFLEX System -
* This source code is CONFIDENTIAL and PROPRIETARY to CUSTOMWARE COMPUTING,
* INC. (CWC). The information contained herein may not be used, copied or
* disclosed in whole or in part except as permitted by written agreement
* signed by an officer of CWC.
*
* COPYRIGHT (c) 1986 CUSTOMWARE COMPUTING, INC., BURLINGAME, CALIFORNIA.
* ALL RIGHTS RESERVED.
*
* Version: %V%  %R%
* Date: %D%  %T%
*************************************************************************/

#include "termflex.h"
#define MAXCRT 100
#define MAXACT 100 

/*
#include "fxstruct.h"
USEREXITS userexits[] = { NULLCHAR, NULLUF };
USERFUNCS userfuncs[] = { NULLCHAR, NULLFUNC };
*/


TERMTBL crttbl[ MAXCRT];
char crtseq[ MAXCRT][ CRTSIZE];
int n_crttbl;

TERMTBL acttbl[ MAXACT];
char actseq[ MAXACT][ ACTSIZE];
int n_acttbl;
static int getrec();
static int initable();
static int buftosh();
static readtermcap();
static int getcapseq();

extern int cwvar3();

char asctermpath[ 256];
char bintermpath[ 256];
static char termname[ 25];

static char seqbuf[1000];

char cwtermpath[ 256];

#ifdef UniFLEX
extern
#endif

TERMVAR termvar;

main()
{
     extern char *getenv();
     char *fxdir;

     initable( &termvar);

     cwtermpath[0] = '\0';
     if ( NULL == (fxdir = getenv( FXDIR) ) ) {
        printf( "\n\r\n\rFXDIR environment variable must be set");
        exit(0);
        }

     strcpy( cwtermpath, fxdir);
     strcat( cwtermpath, PATHSLASH);
     strcat( cwtermpath, "dev");

     printf("\r\n\r\n\r\n\r\n\r\n\r\n\r\n");

     if ( QUIT == menuterm() )
        return(0);

     readascii( &termvar, asctermpath);

     menu( &termvar);

     exit(0);
}


menu( termvar)
TERMVAR *termvar;
{
   char c;
   int dbreak = NO;
   char line[ 90];

   for ( ;dbreak==NO;) {

       printf("\r\n\r\n\r\n\r\n");
       printf(" T E R M I N A L    S U P P O R T   M E N U (%s)\r\n", cwtermpath);
       printf(" ---------------------------------------------------------\n\n");

       printf("     1.  Assign CRT & ACTION KEY Settings\n");
       printf("     2.  Assign ACTION KEYS Settings via Keyboard.\n");
       printf("     3.  Display CRT Settings.\n");
       printf("     4.  Display ACTION KEY Settings.\n");
       printf("     5.  Print Settings.\n");
       printf("     6.  Test Settings.\n");
       printf("     7.  Save Settings.\n");
       printf("     8.  Save & Install Settings to %s.\n", cwtermpath);
       printf("     9.  Load Settings from TERMINFO file.\n");
       printf("     Q.  Quit.\n");
       printf("\n\n");
       printf("         Select Menu Option # ");

       termgetline( line, sizeof(line), stdin);
       c = line[0];
       switch(c) {
          case '1':
             pmtseq( termvar);
             break;
          case '2':
           /*
             printf("NOT implemented at this time.\n");
             break;
           */
             pmtkbaction( termvar);
             break;
          case '3':
             prcrtseq( termvar, DISPLAY);
             break;
          case '4':
             practseq( termvar, DISPLAY);
             break;
          case '5':
             sprintf( line, "pr %s | %s", asctermpath, LPCOMMAND);
             system(line);
             break;
          case '6':
             testterm( termvar);
             break;
          case '7':
             wrascii( termvar, asctermpath);
             writeterm( termvar);
             break;
          case '8':
             wrascii( termvar, asctermpath);
             writeterm( termvar);
             sprintf( line, "%s %s %s", CPCOMMAND, bintermpath, cwtermpath);
             system(line);
             break;
          case '9':
             readtermcap( termvar);
             break;
          case 'B':
             readascii( termvar, asctermpath);
             break;
          case 'R':
             readterm( termvar);
             break;
          case 'b':
          case 'e':
          case 'E':
          case 'Q':
          case 'q':
             dbreak = YES;
             break;
          default:
             printf( "Bad entry --- Try Again");

          }
      }


    return( 0);
}




menuterm()
{
    FILE      *fp1;
    char line[133];
    int    j, i, cc;
    int n_term;
    extern char *getword();

 startover:
    if ((fp1 = fopen("termflex.dir", "r")) == NULL) {
        printf("can't open termflex.dir (%d)\n", errno);
        return(QUIT);
    }
    /* count number of terminals */
    for (n_term=1; termgetline(line, sizeof(line), fp1) != 0; ++n_term);
    rewind( fp1);

    printf("\r\n\r\nSELECT TERMINAL TYPE\r\n\r\n");

    for (i=1, j=(n_term+1)/2;i < (n_term+1)/2;++i, ++j) {
        if (getrec( i, line, fp1))
            printf("%2d. %-30s", i, line);
        if (getrec( j, line, fp1))
            printf("%2d. %-30s", j, line);
        printf("\n");
        }
    if (j <= n_term) {
       printf("                                  ");
       if (getrec( j, line, fp1))
           printf("%2d. %-30s", j, line);
       printf("\n");
       }

    printf("Enter terminal number (a=add, q=quit): ");
    termgetline(line, sizeof( line), stdin);
    if (*line == 'q' || *line == 'Q')
       exit(0);
    if (*line == 'a' || *line == 'A') {
       fmclose(fp1);
       fxaddterm("termflex.dir");
       goto startover;
       }

    cc = atoi(line);

    if (cc >= 1 && cc <= n_term) {
        getrec( cc, line, fp1);
        getword( termname, line);
        strcompress( termname);
        strcpy(bintermpath, termname);
        strcpy(asctermpath, termname);
        strcat(asctermpath, ".asc");
        }
    else {
        printf("Invalid Entry\n");
        return( QUIT);
        }


    fclose(fp1);

    return( 0);
}

static int getrec( recnum, buffer, fp)
int recnum;
char *buffer;
FILE *fp;
{
   int i;
   rewind( fp);
   for (i=1; termgetline(buffer, 130, fp) != 0 && recnum > i;++i);
   if ( recnum != i) 
      return( 0);
   
  return(1);
}





clrseq( termvar, opcode)
TERMVAR *termvar;
int opcode;
{
      int i;

     memset( (char *)*termvar->tv_actseq, '\0', (termvar->tv_nactseq * ACTSIZE));
     memset( (char *)*termvar->tv_crtseq, '\0', (termvar->tv_ncrtseq * CRTSIZE));

}



static int initable( termvar)
TERMVAR *termvar;
{
     int i;

     memset( (char *)termvar, '\0', sizeof(TERMVAR));



     /*  K E Y   S E Q U E N C E S   */
     n_acttbl = MAXACT;
     loadtbl( "termflex.act", acttbl, &n_acttbl);
     termvar->tv_nactseq = n_acttbl; /* assign address of first pointer */
     if ( NULL == ( termvar->tv_actseq = (char **)
                    calloc( termvar->tv_nactseq, sizeof( char *) ) ) ) {
        printf( "Insufficient Memeory");
        exit(1);
        }

     /* initialize array of pointers  */
     for ( i = 0; i < termvar->tv_nactseq; ++i)
         termvar->tv_actseq[i] = actseq[i];



     /*  C R T   C O N T R O L   S E Q U E N C E S    */
     n_crttbl = MAXCRT;
     loadtbl( "termflex.crt", crttbl, &n_crttbl);
     termvar->tv_ncrtseq  = n_crttbl;/* assign address of first pointer */
     if ( NULL == ( termvar->tv_crtseq = (char **)
                    calloc( termvar->tv_ncrtseq, sizeof( char *) ) ) ) {
        printf( "Insufficient Memeory");
        exit(1);
        }

     /* initialize array of pointers  */
     for ( i = 0; i < termvar->tv_ncrtseq; ++i)
         termvar->tv_crtseq[i] = crtseq[i];

     clrseq( termvar, NULL);


}



writeterm(termvar)
TERMVAR *termvar;
{
    TERMHDR termhdr;
    int i, j, fd, nbytes;
        int nalloc, crtnalloc, actnalloc;
        char line[80];


    if (bintermpath == NULL) {
           printf( "Could not open file %s", bintermpath);
           return -1;
           }

    if ( -1 == (fd = open( bintermpath,
                 (O_WRONLY | O_TRUNC | O_CREAT | O_BINARY), MODE_RAW)  ) ) {
           printf( "Could not open file %s", bintermpath);
           return -1;
           }

     /* set-up TERMINAL HEADER  */
    memset((char *)&termhdr, '\0', sizeof(TERMHDR));

    x_shtobuf(termhdr.th_magic, KH_MAGIC);
    strcpy(termhdr.th_version, "VERSION 1.00");
    strncpy(termhdr.th_termname, bintermpath, sizeof( termhdr.th_termname) - 1);

    x_shtobuf(termhdr.th_nactseq, termvar->tv_nactseq);
    x_shtobuf(termhdr.th_ncrtseq, termvar->tv_ncrtseq);

        /* set allocation count for CRT SEQUENCES */
    crtnalloc = 0;
    for (i = 0; i < termvar->tv_ncrtseq; ++i) {
        crtnalloc += strlen(termvar->tv_crtseq[i]) + 1;
            }
    x_shtobuf(termhdr.th_crtnalloc, crtnalloc);

        /* set allocation count for ACTION SEQUENCES */
    actnalloc = 0;
    for (i = 0; i < termvar->tv_nactseq; ++i) {
        actnalloc += strlen(termvar->tv_actseq[i]) + 1;
            }
    x_shtobuf(termhdr.th_actnalloc, actnalloc);



      /* write out TERMINAL HEADER  */
    nbytes = write(fd, (char *)&termhdr, sizeof(TERMHDR));
        if (nbytes < sizeof(TERMHDR)) {
                printf( "Could not write TERMINAL Header");
                fflush( stdout);
        return -1;
                }


      /* write out CRT SEQUENCES */
         /* write each piece because efficiency not an issue here  */
    for (i = 0; i < termvar->tv_ncrtseq; ++i) {
        nalloc = strlen(termvar->tv_crtseq[i]) + 1;
                nbytes = write( fd, termvar->tv_crtseq[i], nalloc);
                if (nbytes < nalloc) {
                    printf( "Could not write CRT SEQUENCES");
                    fflush( stdout);
                return -1;
                    }

/*
                printf( "%3d.  %-30.30s  ",
                      i+1,  crttbl[i].tm_prompt);
                for (j = 0; j < nalloc; ++j)
                    printf( "%4d", termvar->tv_crtseq[i][j] );
                printf( "\n");
*/
            }


      /* write out ACTION KEY SEQUENCES */
         /* write each piece because efficiency not an issue here  */
    for (i = 0; i < termvar->tv_nactseq; ++i) {
        nalloc = strlen(termvar->tv_actseq[i]) + 1;
                nbytes = write( fd, termvar->tv_actseq[i], nalloc);
                if (nbytes < nalloc) {
                    printf( "Could not write ACTION SEQUENCES");
                    fflush( stdout);
                return -1;
                    }

/*
                printf( "%3d.  %-30.30s  ",
                      i+1,  acttbl[i].tm_prompt);
                for (j = 0; j < nalloc; ++j)
                    printf( "%4d", termvar->tv_actseq[i][j] );
                printf( "\n");
*/
            }


        printf( "\r\n\r\n\r\n S A V E     S U M M A R Y \n");

        printf( " header byte count = %d\n", sizeof(TERMHDR));
        printf( " crt byte count    = %d\n", crtnalloc);
        printf( " action byte count = %d\n", actnalloc);
        printf("\r\n\r\nPress RETURN key to continue...");
        termgetline(  line, sizeof line, stdin);
        printf("\r\n\r\n\r\n");
        fflush( stdout);

    close(fd);
    return 0;
}


readterm( termvar)
TERMVAR *termvar;
{

    TERMHDR termhdr;
    char *pseqbuf;
    char *cwgetenv();
    int i, fd, magic, nalloc, nbytes, ncrtseq, nactseq;
    char pathname[ 128];
    extern char *getenv();
    char line[50];

    if (bintermpath == NULL) {
           printf( "Could not open file %s", bintermpath);
           return -1;
           }

    if ( -1 == (fd = open( bintermpath,
                 (O_RDONLY | O_BINARY), MODE_RAW)  ) ) {
           printf( "Could not open file %s", bintermpath);
           return -1;
           }

    if ((nbytes = read(fd, (char *)&termhdr,
       sizeof(TERMHDR))) < sizeof(TERMHDR)) {
        printf( "Could not open file %s", bintermpath);
        return -1;
        }


    if ((magic = buftosh(termhdr.th_magic)) != KH_MAGIC) {
        printf( "Invalid MAGIC number for %s", bintermpath);
        return -1;
        }

  ncrtseq   = buftosh(termhdr.th_ncrtseq);
  nactseq   = buftosh(termhdr.th_nactseq);
  nalloc = buftosh(termhdr.th_crtnalloc)  + buftosh(termhdr.th_actnalloc);
  pseqbuf = seqbuf;
  if (sizeof(seqbuf) <= nalloc) {
    printf("Insufficient memory, nalloc=%d\n",nalloc);
    return -1;
    }

  if ((i = read(fd, pseqbuf, (unsigned) nalloc)) != nalloc) {
    printf("read error, read returned: %d, nalloc=%d\n",i,nalloc);
    return -1;
    }


  clrseq( termvar, NULL);
  for (i = 0; i < ncrtseq; ++i) {
      strcpy(termvar->tv_crtseq[i], pseqbuf);
      pseqbuf += strlen(pseqbuf) + 1;
      }

  for (i = 0; i < nactseq; ++i) {
      strcpy(termvar->tv_actseq[i], pseqbuf);
      pseqbuf += strlen(pseqbuf) + 1;
      }

/*  Diagnostics: */
/*
 for (j = 0; j < strlense(ptr[i]); ++j)
     sprintf( &msg[j * 4], "%4d", crtptr[i][j] );
     message( msgno++, 1, msg, 0);
     if (msgno > 20) {
        msgno = 1;
        message( 23, 1, "--- more ---", 0);
        getkey();
        clrscr();
        }

*/


         /* set TERMVAR counters */
         termvar->tv_ncrtseq = ncrtseq;

         termvar->tv_nactseq = nactseq;


        printf( "\r\n\r\n\r\n R E A D     S U M M A R Y \n");

        printf( " header byte count = %d\n", sizeof(TERMHDR));
        printf( " crt count    = %d\n", ncrtseq);
        printf( " action count = %d\n", nactseq);
        printf("\r\n\r\nPress RETURN key to continue...");
        termgetline(  line, sizeof line, stdin);
        printf("\r\n\r\n\r\n");
        fflush( stdout);

#   ifdef DEBUG
    prterm(termvar);
#   endif

    close(fd);
    return(0);
}


static int buftosh(buf)
char *buf;
{
   short i;

   i = ((buf[0] & CMASK) | ((buf[1] & CMASK) << 8));
   return (int) i;
}


#ifdef DEBUG

prterm( termvar)
TERMVAR *termvar;
{
    int i, j;
    int nalloc;
    char msg[90];
    char msgno = 1;


clrscr();
for (i = 0; i < termvar->tv_ncrtseq; ++i) {
   if ( *termvar->tv_crtseq[i] == NULLCHAR)
       strcpy( msg, "null");
   else
       for (j = 0; j < strlen(termvar->tv_crtseq[i]); ++j)
         sprintf( &msg[j * 4], "%4d", termvar->tv_crtseq[i][j] );
   message( msgno++, 1, msg, 0);
   if (msgno > 20) {
      msgno = 1;
      message( 23, 1, "--- more ---", 0);
      getkey();
      clrscr();
      }
   }

message( 23, 1, "--- actseq ---", 0);
getkey();
clrscr();
msgno = 1;
for (i = 0; i < termvar->tv_nactseq; ++i) {
   if ( termvar->tv_actseq[i] == NULLCHAR)
       strcpy( msg, "null");
   else
      for (j = 0; j < ACTSIZE; ++j)
         sprintf( &msg[j * 4], "%4d", termvar->tv_actseq[i][j] );
     message( msgno++, 1, msg, 0);
     if (msgno > 20) {
        msgno = 1;
        message( 23, 1, "--- more ---", 0);
        getkey();
        clrscr();
        }
     }

        msgno = 1;
        message( 23, 1, "--- summary ---", 0);
        getkey();
        clrscr();
        message(msgno++, 1, "\n\n L O A D     S U M M A R Y \n", 0);
        sprintf(msg, " Crt Sequences     = %d\n", termvar->tv_ncrtseq);
        message(msgno++, 1, msg, 0);
        sprintf(msg, " Action Sequences  = %d\n", termvar->tv_nactseq);
        message(msgno++, 1, msg, 0);

        sprintf(msg, " header byte count = %d\n", sizeof(TERMHDR));
        message(msgno++, 1, msg, 0);
        sprintf(msg, " crt byte count    = ? \n");
        message(msgno++, 1, msg, 0);
        sprintf(msg, " action byte count = %d\n", termvar->tv_nactseq * ACTSIZE);
        message(msgno++, 1, msg, 0);
        sprintf(msg, " Total bytes       = %d\n", nalloc + (sizeof(TERMHDR)));
        message(msgno++, 1, msg, 0);
        message( 23, 1, "--- done ---", 0);
        getkey();
        clrscr();

 return(0);

}

#endif




pmtseq( termvar)
TERMVAR *termvar;
{
    char command[ 100];
    char *editor;
    extern char *getenv();

        wrascii( termvar, "ascterm.tmp");

        if ( NULL == ( editor = getenv( FXEDIT) ) )
            strcpy( command, EDCOMMAND);
        else
            strcpy( command, editor);

        strcat( command, " ascterm.tmp");

        if ( 0 != system( command) ) {
             printf( "error calling editor");
             fflush( stdout);
             }

        readascii( termvar, "ascterm.tmp");

}



prcrtseq( termvar, mode)
TERMVAR *termvar;
int mode;
{

   printf("\n\n");
   printf(" C R T   C O N T R O L   S E Q U E N C E S (%d)\n", termvar->tv_ncrtseq);
   printseq(  crttbl, termvar->tv_crtseq, termvar->tv_ncrtseq );

}

practseq( termvar, mode)
TERMVAR *termvar;
int mode;
{

   printf("\n\n");
   printf(" A C T I O N  /  F U N C T I O N    K E Y S (%d) \n", termvar->tv_nactseq);
   printseq(  acttbl, termvar->tv_actseq, termvar->tv_nactseq );

}


wrascii( termvar, termpath)
TERMVAR *termvar;
char *termpath;
{
    FILE *fp;

    if ( NULL == (fp = fopen( termpath, "w"))) {
        printf( "%s file could not be opened", termpath);
        return( -1);
        }

   writecap(fp, crttbl, termvar->tv_crtseq, termvar->tv_ncrtseq, CRTSIZE);
   writecap(fp, acttbl, termvar->tv_actseq, termvar->tv_nactseq, ACTSIZE);

    fclose( fp);

}

readascii( termvar, termpath)
TERMVAR *termvar;
char *termpath;
{
    FILE *fp;

    if ( NULL == (fp = fopen( termpath, "r"))) {
        printf( "%s file does not exist", termpath);
        return( -1);
        }

   clrseq( termvar, NULL);
   readcap(fp, crttbl, termvar->tv_crtseq, termvar->tv_ncrtseq, CRTSIZE);
   readcap(fp, acttbl, termvar->tv_actseq, termvar->tv_nactseq, ACTSIZE);


   fclose( fp);



}

static readtermcap( termvar)
TERMVAR *termvar;
{

#ifndef VAXVMS
    int i, k;
    static char termdef[ 2024];
    extern char *getenv();

    /* termname = getenv("TERM"); */
    tgetent( termdef, termname);

   /* load CRT terminal settings */
   for ( i = 0; i < MAXCRT; ++i) {

       if (getcapseq( crttbl[i].tm_termcap, termvar->tv_crtseq[i], CRTSIZE) < 0)
          continue;

       if ( strcmp( crttbl[i].tm_tagname, "T_NEWLINE") == 0) {
          termvar->tv_crtseq[i][0] = '\n';
          termvar->tv_crtseq[i][1] = '\0';
          }
       else if ( strcmp( crttbl[i].tm_tagname, "T_TAB") == 0) {
          termvar->tv_crtseq[i][0] = '\t';
          termvar->tv_crtseq[i][1] = '\0';
          }

         } /* end of CRT for loop  */


   /* load ACTIONKEY settings  */
   for ( i = 0; i < MAXACT; ++i) {

/*
       printf("BEFORE: %d) termcap=%s, sequence=", i, acttbl[i].tm_termcap); 
       for ( k = 0; termvar->tv_actseq[i][k] != '\0'; ++k )
               printf( "%d-", (char) termvar->tv_actseq[i][k]);
       printf( "\n ");
       getc(stdin);
*/

       if ( getcapseq( acttbl[i].tm_termcap, &termvar->tv_actseq[i][0], ACTSIZE) ) {
/*
           printf("AFTER:%d) termcap=%s, sequence=", i, acttbl[i].tm_termcap); 
           for ( k = 0; termvar->tv_actseq[i][k] != '\0'; ++k )
                   printf( "%d-", (char) termvar->tv_actseq[i][k]);
           printf( "\n ");
           getc(stdin);
*/
           continue;
           }
/*
       printf("AFTER: NO %d) termcap=%s, sequence=", i, acttbl[i].tm_termcap); 
       for ( k = 0; termvar->tv_actseq[i][k] != '\0'; ++k )
               printf( "%d-", (char) termvar->tv_actseq[i][k]);
       printf( "\n ");
       getc(stdin);
*/

       if ( strcmp( acttbl[i].tm_tagname, "BACKSPACE") == 0) {
          termvar->tv_actseq[i][0] = '\b';
          termvar->tv_actseq[i][1] = '\0';
          }
       else if ( strcmp( acttbl[i].tm_tagname, "ESCAPEKEY") == 0) {
          termvar->tv_actseq[i][0] = 27;
          termvar->tv_actseq[i][1] = 27;
          termvar->tv_actseq[i][2] = '\0';
          }
       else if ( strcmp( acttbl[i].tm_tagname, "ENTERKEY") == 0) {
          termvar->tv_actseq[i][0] = '\r';
          termvar->tv_actseq[i][1] = '\0';
          }
       else if ( strcmp( acttbl[i].tm_tagname, "LINEFEED") == 0) {
          termvar->tv_actseq[i][0] = 10;
          termvar->tv_actseq[i][1] = '\0';
          }
       else if ( strcmp( acttbl[i].tm_tagname, "FWRDTAB") == 0) {
          termvar->tv_actseq[i][0] = '\t';
          termvar->tv_actseq[i][1] = '\0';
          }

      } /* end of inner for loop  */





    printf("\r\n\r\nSucessfully Loaded %s", termname);

#else
    printf( "NOT implemented for VAXVMS version\n");
#endif


    return(0);
}

#ifdef UNIX
static int getcapseq( termcap, ptermseq, maxsize)
char *termcap;
char *ptermseq;
int maxsize;
{
    int i;
    static char termbuf[ 1024];
    char *ptermbuf = termbuf;
    int length;
    extern char *tgetstr();
    char *ptr;
    int capnum;

       /* clear seqence field */
       termbuf[0] = '\0';

       if ( *termcap == '\0') 
          return( NO); 

/*
       printf( "cap = |%s|, ", termcap);
*/

       if ( strcmp( termcap, "sg") == 0) {
          termbuf[0] = '0';  /* default */
          termbuf[1] = '\0';
          if ( (capnum = tgetnum("sg")) >= 0) {
               /* flag is set to use default ^H */ 
               termbuf[0] = capnum + '0';
               termbuf[1] = '\0';
               }
          }

       else if ( strcmp( termcap, "bs") == 0) {

          if ( tgetflag("bs") ) {
               /* flag is set to use default ^H */ 
               termbuf[0] = 8;
               termbuf[1] = '\0';
               }
          else {
               /* doesn't use normal backspace */
               ptr = tgetstr( "bc", &ptermbuf);
               }
           }

        else  {
           ptr = tgetstr( termcap, &ptermbuf);
           if (ptr == NULL) 
              return(NO);
           }

/*
     printf( ":   ");
     for ( i = 0; termbuf[i] != '\0'; ++i )
        printf( "%d ", (int) termbuf[i]);
     printf( "\n ");
*/

      /* strcompress(termbuf); */
      length = strlen( termbuf);
      if (length == 0)
          return(NO);
      if ( length >= maxsize )
         printf( "WARNING: capability too long\n");

      strncpy( ptermseq, termbuf, maxsize - 1);

/*
     printf( "seq: len=%d  ", length);
     for ( i = 0; ptermseq[i] != '\0'; ++i )
        printf( "%d ", (int) ptermseq[i]);
*/

     printf( "\n ");


return(YES);
}

#endif

