#!/bin/sh 
# Original by Kenneth Karlsson 980601  
# email kenneth.karlsson@kennetex.se
#
# Modifications:

# 1998-08-24 by Bjorn, April System Design:
# "unix2dos" (only exists on SUN) replaced with "nawk"

# 2001-01-03 by Bjorn,  April System Design:
# Renamed from anitados to anitadoz.
# Added support for ZModem.
# Changed all ACL commands to use AniTa specific string
# this was needed to allow running in WYSE emulation mode.
# stripped commands: vol, archive and archive2 since they are
# not of common interest.

# 2004-06-07 by Bjorn,  April System Design:
# Added support for scp.  This script requires AniTa 7.1
# to support the new SSEND and SRECEIVE scp commands.
# Added support for Linux echo command.

# echo "$1 $2 $3"
# read answer

##############################################################################
# * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
# * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
# * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
# * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
# * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
# * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
# * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
##############################################################################

# This program makes it easy to write simple unix scripts that can 
# get or send files to or from the pc. All you have to is 
# add a script to the user login profile. 
# The program makes extensive tests to make sure that files are transfered
# without being changed.
 
# Here is an example of .profile :
# 
# anitados get c:/autoexec.bat /tmp/file.txt
# case $?  in
#   0) $ECHO "File transfer OK" ;;
#   *) $ECHO "File transfer failed" ;;
# esac
# anitados send /usr/file c:/windows/temp/file.txt
# anitados copy c:/config.sys c:/config.bak
# RETURN=/tmp/return
# anitados filesize c:/tmp/file.tmp
# case $? in
#   -1) $ECHO "File does not exist" ;;
#   0)  $ECHO "File size is `cat $RETURN`" ;;
# esac 
# anitados del c:/temp/file.tmp
# anitados command start.bat
##############################################################################
# some of the commands returns the reply in the file RETURN
# one way to get it on the screen is to set RETURN to
# your own tty device.  Like this:

# Make it work on UNIX and Linux                     
MYPORT=`uname -s`                                    
if [ "$MYPORT" = "linux" ] || [ "$MYPORT" = "Linux" ]
then                                                 
        ECHO="echo -e"                               
        BACK="\134"                                  
else                                                 
        ECHO="echo"                                  
        BACK="\0134"                                 
fi                             

                      
RETURN=`tty`
export RETURN

# set SCP=TRUE to run scp protocol
# else set ZMODEM=TRUE to run ZModem protocol
# else Kermit protocol will be used
SCP=TRUE
ZMODEM=TRUE
NR=$$
PORT=/dev/tty
TMP1=/tmp/anitatmp1${NR}
TMPNAWK=/tmp/anitanawk${NR}
[ ${RETURN} ] || RETURN=/tmp/return${NR}
COMMAND=/tmp/anitacomm${NR}.bat
PCCOMMAND="c:$BACKanita.bat"
write_nawk()
{
$ECHO "BEGIN {                     
   for (;;)                 
      {                     
      if (getline == 1)     
         printf \"%s\\\r\\\n\", \$0
      else                  
         exit               
      }                     
   }" > $TMPNAWK                       
}

case $1 in
-h|-?|'')
  $ECHO "usage: $0:"
  $ECHO "              get       dosfile unixfile"
  $ECHO "              send      unixfile dosfile"
  $ECHO "              filesize  dosfile"
  $ECHO "              del       dosfile"
  $ECHO "              cd        directory"
  $ECHO "              copy      dosfile1 dosfile2"
  $ECHO "              move      dosfile1 dosfile2"
  $ECHO "              dir       dosfile  (or directory)"
  $ECHO "              command   command.bat (Run dos command on pc)"
  $ECHO "error codes:" 
  $ECHO "              0 = OK"
  $ECHO "              1 = file transfer failure"
  $ECHO "              2 = pc file is missing"
  $ECHO "              3 = unix file is missing"
  $ECHO "              4 = Dos command failed"
  $ECHO "              5 = Wrong parameters"
  exit 0
  ;;
-p)   PORT="`$ECHO $2`" 
      shift
      shift ;;
-p?*) PORT="`$ECHO $1 | cut -c3-`" 
      shift ;;
esac
end0 ()     { rm -f $TMP1 $PCCOMMAND ; exit 0 ; }
end1 ()     { rm -f $TMP1 $PCCOMMAND ; exit 1 ; }
end2 ()     { rm -f $TMP1 $PCCOMMAND ; exit 2 ; }
end3 ()     { rm -f $TMP1 $PCCOMMAND ; exit 3 ; }
end4 ()     { rm -f $TMP1 $PCCOMMAND ; exit 4 ; }
end5 ()     { rm -f $TMP1 $PCCOMMAND ; exit 5 ; }
dostr ()    {  sed s/'\/'/'\\\\'/g ; }
p2check ()  { case ${PAR2} in
             '')  $ECHO "Parameter 1 is missing." 1>&2
                  end5 ;;
            esac ;
            }
p3check ()  { case ${PAR3} in
             '')  $ECHO "Parameter 2 is missing." 1>&2
                  end5 ;;
            esac ;
            }
NR=$$
PAR2=$2
PAR3=$3
PKT=2048
DIRFILES=''
trap ' rm -f $TMP1 $PCCOMMAND ' 1 2 3 15
$ECHO "\033[24ySET DISABLE-COMP-CODES YES"
$ECHO "\033[24yCONTINUE OFF"
case $1 in
  get)
            p2check
            case $3 in
              '') UNIXFILE="`basename ${2}`" ;;
              ?*) UNIXFILE="$3" ;;
            esac
            PCFILE="`$ECHO "$2" | dostr`"
            stty -echo 
            $ECHO "\033[24yFILESIZE $PCFILE" 
            read PCSIZE                                      
            stty echo
            case ${PCSIZE} in
              -1)  $ECHO "PC:  ${PCFILE} is missing" 1>&2
                   end2 ;;
            esac
            stty -echo 
            if [ $SCP = TRUE ]
            then
               $ECHO "\033[24ySET DISABLE-COMP-CODES NO"
               $ECHO "\033[24ySSEND $2 ${UNIXFILE} "
               read REPLY
            elif [ $ZMODEM = TRUE ]
            then
               $ECHO "\033[24yZSEND $2 "
               rz
              if [ ${UNIXFILE} != "`basename ${2}`" ] 
              then
                 if [ -f ${UNIXFILE} ]
                 then                       
                    rm ${UNIXFILE}
                 fi
                 mv "`basename ${2}`" ${UNIXFILE}
              fi
            else
               $ECHO "\033[24yKSEND $2 "
               kermit -e ${PKT} -i -k > $UNIXFILE 
            fi
            stty echo 
            if [ -f ${UNIXFILE} ]
            then                       
               UNIXSIZE=`ls -l ${UNIXFILE} | awk ' { print $5 }'` 
            else                                             
               $ECHO "UNIX:  ${UNIXFILE} is missing" 1>&2
               end3
            fi                                               
            $ECHO "PC file = ${PCSIZE}    UNIX file = ${UNIXSIZE}"  1>&2
            if [ ${PCSIZE-0} != ${UNIXSIZE-1} ] 
            then
              $ECHO "PC file = ${PCSIZE}    UNIX file = ${UNIXSIZE}"  1>&2
              $ECHO "Files do not match. UNIX file will be deleted."  1>&2
              rm -f ${UNIXFILE}
              end1
            fi                                                    
            ;;
  send)
            p2check
            UNIXFILE="${2}"
            if [ ! -f ${UNIXFILE} ] 
            then
               $ECHO "UNIX:   ${UNIXFILE} is missing." 1>&2
               end3 
            fi
            UNIXSIZE=`ls -l ${UNIXFILE} | awk ' { print $5 }'` 
            case $3 in
              ?*) PCFILE="`$ECHO "${3}" | dostr`" ;;
              '') PCFILE="`basename ${UNIXFILE}`" ;;
            esac
            stty -echo
            if [ $SCP = TRUE ]
            then
               $ECHO "\033[24ySET DISABLE-COMP-CODES NO"
               $ECHO "\033[24ySRECEIVE ${UNIXFILE} ${PCFILE}"
               read REPLY
            elif [ $ZMODEM = TRUE ]
            then
               $ECHO "\033[24yZRECEIVE ${PCFILE}"
sleep 1
               sz ${UNIXFILE}
            else
               $ECHO "\033[24yKRECEIVE ${PCFILE}"
               kermit -C "set send packet-length ${PKT}" -i -s ${UNIXFILE}
            fi
            $ECHO "\033[24yFILESIZE ${PCFILE}" 
            read PCSIZE                                      
            stty echo
            case ${PCSIZE} in
              -1)  $ECHO "PC:  ${PCFILE} has not been transfered." 1>&2
                   end2 ;;
            esac
            $ECHO "PC file = ${PCSIZE}    UNIX file = ${UNIXSIZE}"  1>&2
            if [ ${PCSIZE-0} != ${UNIXSIZE-1} ] 
            then
              $ECHO "PC file = ${PCSIZE}    UNIX file = ${UNIXSIZE}"  1>&2
              $ECHO "Files do not match. PC file will be deleted." 1>&2
              $ECHO "\033[24ySET DISABLE-COMP-CODES YES"
              $ECHO "\033[24yERASE ${PCFILE}"
              end1
            fi                                                    
            ;;
  filesize) 
            p2check
            PCFILE=$2
            stty -echo
            $ECHO "\033[24yFILESIZE ${PCFILE}"
            read PCSIZE                                      
            stty echo
            case ${PCSIZE} in
              -1)  $ECHO "PC:  ${PCFILE} is missing." 1>&2
                   end2 ;;
              ?*)  $ECHO "${PCSIZE}" > ${RETURN} ;;                             
            esac 
            ;;
                       
  del)
            p2check
            PCFILE="`$ECHO "${2}" | dostr`"
            stty -echo
            $ECHO "\033[24yFILESIZE ${PCFILE}"
            read PCSIZE                                      
            stty echo
            case ${PCSIZE} in 
              -1)  $ECHO "PC:   ${PCFILE} is missing" 1>&2
                   end2 ;;
            esac 
            stty -echo
            $ECHO "\033[24yERASE ${PCFILE}"
            $ECHO "\033[24yFILESIZE ${PCFILE}"
            read PCSIZE                                      
            stty echo
            case ${PCSIZE} in
              -1) : ;; 
              *)  $ECHO "PC:   ${PCFILE} has not been deleted" 1>&2
                  end4 ;; 
            esac 
            ;;
  cd)
            p2check
            stty -echo
            $ECHO "\033[24ySET DISABLE-COMP-CODES NO" 
	    PCFILE="`$ECHO "${2}" | dostr`"
            $ECHO "\033[24yCD ${PCFILE}"
            read REPLY                                      
            stty echo
            case ${REPLY} in 
              S*) : ;; 
              *)  $ECHO "Could not change directory" 1>&2
                  end4 ;;
            esac
            $ECHO "\033[24ySET DISABLE-COMP-CODES YES"
            ;;
  copy)
            p2check
            p3check
            PCFILE="`$ECHO "${2}" | dostr`"
            stty -echo
            $ECHO "\033[24yFILESIZE ${PCFILE}"
            read PCSIZE                                      
            stty echo
            case ${PCSIZE} in 
              -1)  $ECHO "PC:   ${PCFILE} is missing" 1>&2
                   end2  ;;
            esac 
            PCFILE2="`$ECHO "${3}" | dostr`"
            stty -echo
            $ECHO "\033[24yCOPY ${PCFILE} ${PCFILE2}"
            $ECHO "\033[24yFILESIZE ${PCFILE2}"
            read PCSIZE2                                      
            stty echo
            case ${PCSIZE2} in
              -1)  $ECHO "PC:   ${PCFILE} has not been copied" 1>&2
                   end4 ;; 
            esac 
            if [ ${PCSIZE-0} != ${PCSIZE2-1} ] 
            then
              $ECHO "PC file 1 = ${PCSIZE}    PC file 2 = ${PCSIZE2}"  1>&2
              $ECHO "Files do not match. PC file 2 will be deleted." 1>&2
              $ECHO "\033[24yERASE ${PCFILE2}"
              end4
            fi                                                    
            ;;
  move)
            p2check
            p3check
            PCFILE="`$ECHO "${2}" | dostr`"
            stty -echo
            $ECHO "\033[24yFILESIZE ${PCFILE}"
            read PCSIZE                                      
            stty echo
            case ${PCSIZE} in 
              -1)  $ECHO "PC:   ${PCFILE} is missing" 1>&2
                   end2 ;;
            esac 
            PCFILE2="`$ECHO "${3}" | dostr`"
            stty -echo
            $ECHO "\033[24yCOPY ${PCFILE} ${PCFILE2}"
            $ECHO "\033[24yFILESIZE ${PCFILE2}"
            read PCSIZE2                                      
            stty echo
            case ${PCSIZE2} in
              -1)  $ECHO "PC:   ${PCFILE} has not been copied" 1>&2
                   end4 ;; 
            esac 
            if [ ${PCSIZE-0} = ${PCSIZE2-1} ] 
            then
              stty -echo
              $ECHO "\033[24yERASE ${PCFILE}"
              $ECHO "\033[24yFILESIZE ${PCFILE}"
              read PCSIZE                                      
              stty echo
              case ${PCSIZE} in 
                -1) : ;;
                ?*) $ECHO "Original file ${PCFILE} has not been deleted" 1>&2
                    $ECHO "\033[24yERASE ${PCFILE2}"
                    end4  ;;
              esac 
            else                                             
              $ECHO "PC file 1 = ${PCSIZE}    PC file 2 = ${PCSIZE2}"  1>&2
              $ECHO "Files do not match. PC file 2 will be deleted." 1>&2
              $ECHO "\033[24yERASE ${PCFILE2}"
              end4
            fi                                                    
            ;;
  dir)
            case ${2} in
             ?*) PCFILE="`$ECHO "${2}" | dostr`"
                 $ECHO "${PCFILE}" | grep '*' > /dev/null
                 case $? in
                   0) : ;;
                   *) stty -echo
                      $ECHO "\033[24yFILESIZE ${PCFILE}"
                      read PCSIZE                                      
                      stty echo
                      case ${PCSIZE} in 
                        -1)  $ECHO "PC:   ${PCFILE} is missing" 1>&2
                             end2 ;;
                      esac ;;
                 esac ;;
            esac
            stty -echo                                      
            $ECHO "\033[24yDIR $PCFILE"
            read REPLY                              
            while [ ${REPLY} ]
            do                                              
              DIRFILES="${DIRFILES}${REPLY}	"
              read REPLY                              
            done
            stty echo                               
            case ${DIRFILES} in
              ?*) $ECHO "${DIRFILES}" > ${RETURN} ;;
              *)  end4 ;;
            esac
            ;;
  command)
            p2check
            shift
            P0="`$ECHO $* | dostr`" 
            $ECHO "@echo off" > $TMP1
            $ECHO "${P0}" >> $TMP1
#            unix2dos -ascii < $TMP1 > $COMMAND
            write_nawk
            nawk -f $TMPNAWK $TMP1 > $COMMAND
#$ECHO "$TMP1"
#cat $TMP1
$ECHO "PC command file:"
cat $COMMAND
            rm $TMPNAWK
            stty -echo
            if [ $SCP = TRUE ]
            then
               $ECHO "\033[24ySRECEIVE $PCCOMMAND"
            elif [ $ZMODEM = TRUE ]
            then
               $ECHO "\033[24yZRECEIVE $PCCOMMAND"
               sz $COMMAND
            else
               $ECHO "\033[24yKRECEIVE $PCCOMMAND"
               kermit -C "set send packet-length ${PKT}" -i -s $COMMAND
            fi
            $ECHO "\033[1;0y${PCCOMMAND}\033$BACK" 
            stty echo
            sleep 5
            ;;
esac
end0

