

#include <stdio.h>
#define XENIX
#define WILDCARD '@'

char *device = {"/dev/fd1135ds18:"}; 
/* char *device = {"/dev/hd0d:"}; */

#define MAXBUF 256
extern char *dirname();
extern char *basename();
extern char *strchr();
extern char *getcwd();

static char usage[] = { "USAGE(*=@):  getdos [-b] sourcepath destdir\n" };

static char example[] = { "EXAMPLE:  getdos /@ .\n" };
 

main( argc, argv)
int argc;
char *argv[];
{
     int i;
     char command[ MAXBUF];
     int dosflag;

     static char srcpath[133];
     static char srcdir[133];
     static char srcbase[133];
     static char destdir[133];


    if (argc < 3) {
      printf( usage); 
      printf( example); 
      exit( 1);
      }

     for ( i = 1; i < argc  ; ++i) {
        printf( "%d\n", i);
        if (argv[i][0] != '-' ) {
           strcpy(srcpath, argv[i]);
           strcpy(destdir, argv[i + 1]);
           break;
           }
        switch( argv[i][1]) {
            case 'b': 
                dosflag = 'b';
                break;
            default: 
                printf( "ERROR: Invalid flag field entered\n");
                printf( usage); 
                exit(1);
            }

       }  /* for loop */

        

    if ( strcmp( destdir, ".") == 0 ) {
       strcpy( destdir, getcwd(NULL, MAXBUF));
       }
    
    strcpy( command, "cd ");
    strcat( command, destdir);
    if ( 0 != system( command) ) {
        printf( "Bad destination directory %s\n",  destdir );
        printf( usage); 
        exit(1);
        } 

    strcpy( srcdir, dirname( srcpath));
    strcpy( srcbase, basename( srcpath));

#ifdef XENIX
     printf( "XENIX version\n");
     dosxnx3( srcdir, srcbase, destdir, dosflag);
#endif

#ifdef UNIX_V 
     dosVunx( srcdir, srcbase, destdir, dosflag);
#endif

    exit(0);
}




char *dirname( path)
char *path;
{
    int i;
    static char dirpath[133];
    char *p;
    int len;

    len = strlen( path);

    strcpy( dirpath, path);

    for (i = len, p = (dirpath+len-1); i > 0 && *p != '/'; --i, --p);

    *p = '\0';
       
    return( dirpath);
}


char *basename( path)
char *path;
{
    int i, j;
    static char base[133];
    char *p;
    int len;
    extern char *malloc();

    len = strlen( path);
    for (i = len, j = 0, p = (path+len-1); i > 0 && *p != '/'; --i, ++j, --p);

    strcpy( base, ++p);
       
    return( base);
}


#ifdef XENIX
dosxnx3( srcdir, srcbase, destdir, dosflag)
char *srcdir;
char *srcbase;
char *destdir;
int dosflag;
{
     int i, j;
     char command[ MAXBUF];
     FILE *fp;
     char filename[40];
     char file[ 30];
     char ext[ 10];
     char line[ MAXBUF];

    if ( strchr( srcbase, WILDCARD) == NULL) {
         doscopy( srcdir, srcbase, destdir, dosflag);
         exit(0);
         }


     strcpy( command, "dosdir ");
     strcat( command, device);
     strcat( command, srcdir); 
     strcat( command,  " > dostemp");
     printf( "%s\n", command);
     if ( system( command) != 0) {
        printf( "Unable to list source directory %s\n",
                srcbase, destdir );
        printf( usage); 
        exit(1);
        }

    if ( NULL == (fp = fopen( "dostemp", "r")) ) {
       printf( "Unable to open directory listing for dostemp\n\n");
       exit(1);
       }

    for ( ; ; ) {
        if (NULL == fgets( line, MAXBUF, fp) )
           break;

        if ( line[0] == '\0' || line[0] == ' ' || line[0] == '.' ) 
           continue;
        
        for ( i = 0; i < 8 && line[i] != ' '; ++i) 
            file[i] = tolower( line[i]);
        file[i] = '\0';  

        for (i = 9, j = 0; line[i] != ' '; ++i, ++j) 
            ext[j] = tolower( line[i]);
        ext[j] = '\0';  

        strcpy( filename, file);
        if ( *ext != '\0')  {
            strcat( filename, ".");
            strcat( filename, ext);
            }

        if (filename[0] < 'A' || filename[0] > 'z')
           continue;  

        if ( wildncmp( filename, srcbase, 99) != 0)
            continue;
        
        /*
        printf( "wildncmp(): %s  %s\n", filename, srcbase);
        */

        doscopy( srcdir, filename, destdir, dosflag);
        }
       
    fclose( fp);

    unlink( "dostemp");

    exit(0);
}

doscopy( srcdir, srcbase, destdir, dosflag)
char *srcdir;
char *srcbase;
char *destdir;
int dosflag;
{
    char command[ MAXBUF];

         strcpy( command, "doscp ");
         if ( dosflag == 'b') 
             strcat( command, "-r ");
         strcat( command, device);
         strcat( command, srcdir);
         strcat( command, "/");
         strcat( command, srcbase);
         strcat( command, " ");
         strcat( command, destdir);
         strcat( command, "/");
         strcat( command, srcbase);
         strcat( command, " > /dev/null");
         printf( "%s\n", command);
         if ( system( command) != 0) {
            printf( "Unable to copy file %s to destination directory %s\n",
                    srcbase, destdir );
            printf( usage); 
            exit(1);
            }

}

#endif

/*
*	int	wildncmp( s, ws, n )
*		char	*s, *ws;
*		int	n;
*
*	Compare the string pointed to by s to the string pointed to
*	by ws, where the string pointed to by ws may or may not
*	contain wildcards.  The number n indicates the maximum
*	length to search (s and ws may or may not be null-terminated).
*	The valid wildcard characters are * (0 or more of any 
*	character) and ? (any single character).  This function 
*	returns 0 if the strings match, -1 if the first string is
*	less than the second string, and 1 if the first string is
*	greater than the second string.  If a wildcard character
*	is used, the greater than or less than result may not be
*	meaningful (other than to indicate that the strings do
*	not match). 
*/

wildncmp( s, ws, n )
char	*s, *ws;
int	n;
{
	char	*orig_ws = ws;			/* save for compare at end */
	int	orig_n = n;

	for ( ; n; n-- ) {

		if ( ! *s && ! *ws ) 
			return( 0 );		/* at end of both : match */

		if ( ! *s && *ws != WILDCARD)
			return( -1 );		/* at end of s : mismatch */
		
		if ( *ws == '?' ) {
			s++;			/* ? matches single char */
			ws++;
			continue;
		}

		if ( *ws == WILDCARD ) {

			if ( ! *(ws+1) ) 
				return( 0 );	/* * at end of ws : match */
 
			if ( ! *s )
				return( -1 );	/* end s, not ws : mismatch */

			if ( wildncmp( s, (ws+1), n ) == 0 )
				return( 0 );	/* matched remaining portion */

			s++;			/* * matches any character */
			continue;

		}

		if ( *s != *ws ) {		/* normal char mismatch */
			if ( *s > *ws )
				return( 1 );
			else
				return( -1 );
		}

		s++;				/* advance */
		ws++;

	}

	if ( ws - orig_ws < orig_n && *ws )
		return( -1 );			/* should be at end of ws */
	else
		return( 0 );			/* match */

} 
